/**************************************************
 * VRML 2.0, Draft 2 Parser
 * Copyright (C) 1996 Silicon Graphics, Inc.
 *
 * Author(s)	: Gavin Bell
 *                Daniel Woods (first port)
 **************************************************
 */

/* A lexical scanner generated by flex */


#define FLEX_SCANNER

#include <io.h>
#include <stdlib.h>
#include <stdio.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>
//#include <unistd.h>

/* Use prototypes in function declarations. */
#define YY_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#ifdef __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */


#ifdef __TURBOC__
#define YY_USE_CONST
#endif


#ifndef YY_USE_CONST
#ifndef const
#define const
#endif
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.
 */
#define YY_START ((yy_start - 1) / 2)

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file".  Now included
 * only for backward compatibility with previous versions of flex.
 */
#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state *YY_BUFFER_STATE;

extern int yyleng;
extern FILE *yyin, *yyout;

#ifdef __cplusplus
extern "C" {
#endif
	extern int yywrap YY_PROTO(( void ));
#ifdef __cplusplus
	}
#endif

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		yyless( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yyless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		*yy_cp = yy_hold_char; \
		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )


struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	int yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2
	};

static YY_BUFFER_STATE yy_current_buffer = 0;

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_CURRENT_BUFFER yy_current_buffer


/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;

static int yy_n_chars;		/* number of characters read into yy_ch_buf */


int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 1;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

static void yyunput YY_PROTO(( int c, char *buf_ptr ));
void yyrestart YY_PROTO(( FILE *input_file ));
void yy_switch_to_buffer YY_PROTO(( YY_BUFFER_STATE new_buffer ));
void yy_load_buffer_state YY_PROTO(( void ));
YY_BUFFER_STATE yy_create_buffer YY_PROTO(( FILE *file, int size ));
void yy_delete_buffer YY_PROTO(( YY_BUFFER_STATE b ));
void yy_init_buffer YY_PROTO(( YY_BUFFER_STATE b, FILE *file ));

static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int *yy_start_stack = 0;
static void yy_push_state YY_PROTO(( int new_state ));
static void yy_pop_state YY_PROTO(( void ));
static int yy_top_state YY_PROTO(( void ));

static void *yy_flex_alloc YY_PROTO(( unsigned int ));
static void *yy_flex_realloc YY_PROTO(( void *, unsigned int ));
static void yy_flex_free YY_PROTO(( void * ));

#define yy_new_buffer yy_create_buffer

#define INITIAL 0
#define NODE 1
#define SFB 2
#define SFC 3
#define SFF 4
#define SFIMG 5
#define SFI 6
#define SFR 7
#define SFS 8
#define SFT 9
#define SFV2 10
#define SFV3 11
#define MFC 12
#define MFF 13
#define MFI 14
#define MFR 15
#define MFS 16
#define MFV2 17
#define MFV3 18
#define IN_SFS 19
#define IN_MFS 20
#define IN_SFIMG 21
typedef unsigned char YY_CHAR;
typedef int yy_state_type;

#define FLEX_DEBUG
FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;
extern char *yytext;
#define yytext_ptr yytext

#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO(( char *, const char *, int ));
#endif

#ifdef __cplusplus
static int yyinput YY_PROTO(( void ));
#else
static int input YY_PROTO(( void ));
#endif

static yy_state_type yy_get_previous_state YY_PROTO(( void ));
static yy_state_type yy_try_NUL_trans YY_PROTO(( yy_state_type current_state ));
static int yy_get_next_buffer YY_PROTO(( void ));
static void yy_fatal_error YY_PROTO(( const char msg[] ));

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yytext_ptr = yy_bp; \
	yyleng = yy_cp - yy_bp; \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define YY_END_OF_BUFFER 49
static const short int yy_accept[1007] =
    {   0,
        3,    3,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,   49,    3,    3,   46,    3,   47,
       45,   16,   45,   16,   16,   16,   16,   16,   16,   16,
       16,   16,   16,   47,   47,   47,   47,   47,   47,   47,
       47,   25,   47,   47,   47,   47,   23,   23,   47,   47,
       47,   37,   36,   37,   37,   47,   47,   35,   47,   47,
       47,   47,   47,   47,   47,   47,   47,   47,   19,   20,

       47,   47,   26,   47,   24,   24,   47,   47,   47,   38,
       38,   38,   47,   47,   47,   47,   47,   47,   40,   40,
       41,   40,   40,   42,   47,   44,   44,    3,    3,   46,
        3,   46,   46,    3,    3,    3,    3,   45,   45,   16,
       45,   45,   45,   16,   16,    9,   16,   16,   16,    8,
       16,   16,   16,   16,    0,   17,    0,    0,    0,    0,
        0,    0,    0,   25,   25,    0,    0,    0,    0,   23,
       23,    0,    0,    0,    0,    0,   37,   37,   37,   17,
        0,   35,   35,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,   18,    0,

       26,   26,   24,   24,    0,    0,    0,    0,    0,   38,
       38,   38,   18,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,   40,   40,   40,   40,   40,   40,   39,
       44,   44,   46,   46,   46,    3,    6,   16,   16,   16,
       16,    7,   16,   16,   16,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,   43,
       43,    0,    0,    0,    0,   43,   43,    0,   23,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,   27,    0,    0,    0,    0,    0,   27,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,   24,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,   28,    0,    0,    0,    0,
        0,   28,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   44,    3,   16,   11,   16,   16,   16,   16,
       16,    0,   21,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,   25,   43,   43,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,   35,    0,    0,   27,
       27,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

       26,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   28,   28,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    3,   16,    4,   10,   16,   16,   14,
       22,    0,    0,    0,   33,    0,    0,    0,    0,    0,
       33,    0,    0,    0,   33,    0,    0,    0,   33,    0,
        0,    0,    0,    0,   33,   43,   43,   43,   43,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,   29,    0,
        0,    0,    0,    0,   29,    0,    0,    0,   29,    0,

        0,    0,   29,    0,    0,    0,    0,    0,   29,    0,
        0,    0,   34,    0,    0,    0,    0,    0,   34,    0,
        0,    0,   34,    0,    0,    0,   34,    0,    0,    0,
        0,    0,   34,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   30,    0,    0,    0,    0,    0,   30,    0,
        0,    0,   30,    0,    0,    0,   30,    0,    0,    0,
        0,    0,   30,    3,   16,   16,   16,   16,    0,    0,
       33,   33,    0,    0,    0,   33,   33,   33,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
       27,    0,    0,   27,    0,    0,   29,   29,    0,    0,
        0,   29,   29,   29,    0,    0,   34,   34,    0,    0,
        0,   34,   34,   34,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,   28,    0,    0,   28,
        0,    0,   30,   30,    0,    0,    0,   30,   30,   30,
        3,    3,   16,   12,   16,   16,    0,    0,    0,    0,
        0,    0,    0,    0,   31,    0,    0,    0,    0,    0,

       31,    0,    0,    0,   31,    0,    0,   31,    0,    0,
        0,    0,    0,   31,    0,    0,    0,   31,    0,    0,
        0,   31,    0,    0,    0,    0,    0,   31,    0,    0,
        0,    0,   31,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,   32,    0,    0,    0,
        0,    0,   32,    0,    0,    0,   32,    0,    0,   32,
        0,    0,    0,    0,    0,   32,    0,    0,    0,   32,
        0,    0,    0,   32,    0,    0,    0,    0,    0,   32,
        0,    0,    0,    0,   32,    0,    0,    0,    0,    0,
        3,    3,   16,   13,   16,    0,   33,    0,    0,   33,

        0,    0,   33,    0,   33,    0,    0,   33,    0,    0,
       31,   31,    0,    0,    0,   31,   31,   31,    0,    0,
        0,   31,   31,   31,    0,    0,    0,    0,    0,   31,
        0,   29,    0,    0,   29,    0,    0,   29,    0,   29,
        0,    0,   29,    0,   34,    0,    0,   34,    0,    0,
       34,    0,   34,    0,    0,   34,    0,    0,   32,   32,
        0,    0,    0,   32,   32,   32,    0,    0,    0,   32,
       32,   32,    0,    0,    0,    0,    0,   32,    0,   30,
        0,    0,   30,    0,    0,   30,    0,   30,    0,    0,
       30,    3,    3,   16,   16,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    3,    3,   16,   16,    0,   31,    0,
        0,   31,    0,    0,   31,    0,   31,    0,    0,   31,
        0,    0,   31,    0,   31,    0,    0,   31,    0,    0,
       31,    0,   32,    0,    0,   32,    0,    0,   32,    0,
       32,    0,    0,   32,    0,    0,   32,    0,   32,    0,
        0,   32,    0,    0,   32,    3,    3,    5,   16,    3,
        3,   15,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    1,    3,    3,    1,    1,    3,    1,    1,    1,
        3,    3,    3,    3,    3,    3,    3,    3,    2,    3,

        2,    2,    2,    2,    2,    0
    } ;

static const int yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    2,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    5,    5,    5,    1,    5,
        5,    5,    8,    2,    9,   10,    5,   11,   12,   13,
       12,   12,   12,   12,   12,   14,   12,    5,    5,    5,
        5,    5,    5,    5,   15,   16,   16,   17,   18,   19,
        5,    5,   20,    5,    5,   21,   22,   23,   24,   25,
        5,   26,   27,   28,   29,   30,    5,   31,    5,    5,
       32,   33,   34,    5,    5,    5,   35,   16,   16,   36,

       37,   38,    5,    5,   39,    5,    5,   40,    5,   41,
       42,   43,    5,   44,   45,   46,   47,   48,    5,   49,
        5,    5,    1,    5,    1,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5
    } ;

static const int yy_meta[50] =
    {   0,
        1,    2,    3,    2,    4,    5,    6,    4,    4,    1,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    8,    1,    8,    7,    7,    7,    7,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4
    } ;

static const short int yy_base[1181] =
    {   0,
        0,    6,   13,    0,   61,   67,   94,    0,  106,  112,
      118,  124,  130,  136,  142,  148,  161,  167,  166,  179,
      185,  191,  197,  203,  209,  235,  261,  287,  313,  339,
      365,  391,  424,  457,  483,  509,  535,  561,  224,  230,
      258,  276,  326,  352,  664,    0,   75,   81,  282, 8542,
      249,    0,  301,  645,  630,  633,  626,  628,  629,  627,
      623,   18,  607,  622,  603,  591,   80,   98,  594,  172,
      302,  318,  330,  607,   53,  343,  375,  356,  370,  379,
      655,    0, 8542,  406,  589,  404,  408,  422,  427,  434,
      668,  439,  454,  681,  459,  467,  694,  588, 8542, 8542,

      472,  487,  494,  498,  519,  513,  524,  540,  707,    0,
      554,  586,  552,  565,  720,  612,  571,  733,    0,  587,
     8542,  625,  606, 8542,  622,  737,  628,    0,  641,  645,
      750,  754,  758,  767,  773,  780,  786,  792,  798,    0,
      804,  811,  817,  584,  574,    0,  579,  575,  563,    0,
      569,  543,  516,  505,  519, 8542,  510,  814,    0,  827,
      863,  876,  835,  840,  844,    0,  889,  902,  915,  912,
        0,  916,    0,  929,  965,  978,    0,  942,  948,    0,
      945,  950,  982,  990,    0, 1018, 1054, 1067,  994,    0,
     1080, 1116, 1129,  998,    0, 1142, 1178, 1191, 8542, 1002,

     1027, 1035, 1031,    0, 1088,    0, 1204, 1240, 1253,    0,
     1103, 1165,    0, 1100, 1266, 1279, 1315, 1328, 1150, 1341,
     1354, 1390, 1403,    0, 1171, 1217, 1223, 1229, 1292, 8542,
     1226,    0, 1298, 1299, 1305, 1367,    0,  510,  495,  486,
      485,    0,  461,  448,  448,  460,  458, 1367, 1372, 1407,
     1420, 1433, 1446,    0,    0, 1450, 1463, 1460, 1464, 1468,
     1472, 1516, 1529, 1542, 1555, 1568,  193, 1485,    0, 1482,
     1490, 1494, 1616, 1629, 1642,    0,    0, 1498, 1581, 1578,
     1589, 1594, 1502, 1599, 1655,    0,    0,    0, 1582,    0,
     1662, 1667, 1671, 1684, 1697,    0,    0,    0, 1701, 1714,

     1711, 1716, 1720, 1733, 1746,    0,    0,    0, 1750, 1763,
     1760,    0, 1767, 1772, 1776, 1789, 1802,    0,    0,    0,
     1806, 1819, 1816, 1821, 1825, 1830, 1843,    0,    0,    0,
     1847,    0, 1854, 1859, 1863, 1876, 1889,    0,    0,    0,
     1893, 1906,    0, 1912,  449,    0,  450,  444,  411,  410,
      418,  411, 8542, 1909, 1932, 1945, 1981, 1994, 2007, 2036,
     2072, 2085, 1913, 1917,    0, 2089, 1953, 2137, 2150, 2186,
     2199, 2212, 2241, 2277, 2290, 1957, 1961, 1965, 2303, 2015,
     2023, 2044, 2316, 2329, 2365, 2378, 2391, 2427, 2440, 2453,
     2050, 2466, 2479, 2515, 2528, 2541, 2577, 2590, 2603, 2054,

     2058, 2098, 2616, 2629, 2665, 2678, 2691, 2727, 2740, 2753,
     2102, 2766, 2118, 2779, 2158, 2815, 2828, 2864, 2877, 2890,
     2926, 2939, 2952, 2036,  384,    0,    0,   52,  361,    0,
     8542, 2165, 2170, 2220, 2225, 2965, 2978,    0,    0, 2229,
        0, 2991, 3004, 2234, 2115, 3017, 2250, 2254, 3030, 3043,
        0,    0,    0, 2258,    0,    0, 3057,  209,  219, 2337,
     2263, 2341, 3105, 3118, 3131,    0,    0, 2345, 2358, 3144,
     3157, 2400, 2413, 3170, 2411, 2487, 3183, 3196,    0,    0,
        0, 2491, 2504, 2501, 3209, 2549, 2554, 2558, 2563, 3222,
     3235,    0,    0, 2637,    0, 3248, 3261, 2642, 2655, 3274,

     2700, 2704, 3287, 3300,    0,    0,    0, 2708,    0, 2787,
     2713, 2791, 2796, 3313, 3326,    0,    0, 2800,    0, 3339,
     3352, 2837, 2850, 3365, 2848, 2898, 3378, 3391,    0,    0,
        0, 2902,    0, 2909, 3396, 3400, 3413, 3426, 3439,    0,
        0, 3443, 3456, 3462, 3475, 3480, 3493, 3499, 3504, 3508,
     3521, 3534,    0,    0,    0, 3538, 3551, 3548, 3561, 3568,
     3573, 3577, 3582, 3595, 3608,    0,    0, 3612,    0, 3625,
     3638, 3643, 3656, 3662, 3667, 3671, 3684, 3697,    0,    0,
        0, 3701,    0, 3714,  371,  319,  311,  298, 3711, 3743,
     3715, 3756, 3792, 3805, 3732, 3818, 3854, 3890, 3729, 3926,

     3939, 3975, 3988, 4001, 4037, 4050, 4063, 4076, 4089, 3769,
     4102, 4131, 4167, 4180, 4193, 4229, 4242, 4278, 4291, 3766,
     3770, 4304, 4317,    0, 3774, 4330, 3826, 4343, 4379, 4392,
     3839, 4405, 4441, 4477, 3778, 4513, 3836, 4526, 4562, 4575,
     3867, 4588, 4624, 4660, 3864, 4696, 4709, 4745, 4758, 4771,
     4807, 4820, 4833, 4846, 4859, 3877, 4872, 4901, 4937, 4950,
     4963, 4999, 5012, 5048, 5061, 3874, 3898, 5074, 5087,    0,
     3902, 5100, 3907, 5113, 5149, 5162, 3952, 5175, 5211, 5247,
     3962, 3968,  294,    0,  260,  283, 4009, 5283, 5296, 4016,
     5309, 4023, 4111, 3949, 4116, 5322, 5335,    0,    0, 4120,

        0, 5348, 5361, 4140, 4153, 4151, 4124, 5374, 5387, 5400,
        0,    0, 4201,    0, 5413, 5426, 4206, 4219, 5439, 4251,
     4255, 5452, 5465,    0,    0,    0, 4259,    0, 4351, 5478,
     5491, 4264, 4364, 4361, 5504, 5517, 4413, 5530, 4420, 5543,
     5556, 4427, 5569, 4449, 4454, 4365, 4459, 5582, 5595,    0,
        0, 4463,    0, 5608, 5621, 4486, 4499, 4497, 4534, 5634,
     5647, 5660,    0,    0, 4538,    0, 5673, 5686, 4543, 4601,
     5699, 4548, 4598, 5712, 5725,    0,    0,    0, 4602,    0,
     4609, 5738, 5751, 4633, 4646, 4643, 5764, 5777, 4668, 5790,
     4682, 4722,  270,    0,  253, 4679, 4722, 5803, 5816,    0,

     5829, 5842, 4735, 4779, 5855, 5868, 5881,    0, 4783, 5894,
     4788, 5907, 5943, 5956, 4885, 5969, 6005, 6041, 6077, 6090,
     4891, 6103, 6139, 6175, 4888, 6211, 6224, 6237, 4901, 6250,
     4909, 4913, 6286, 6299,    0, 6312, 6325, 4926, 4923, 6338,
     6351, 6364,    0, 4971, 4975, 6377, 6390,    0, 6403, 6416,
     4988, 4985, 6429, 6442, 6455,    0, 5020, 6468, 5029, 6481,
     6517, 6530, 5126, 6543, 6579, 6615, 6651, 6664, 5132, 6677,
     6713, 6749, 5024, 6785, 6798, 6811, 5138, 6824, 5135, 5183,
     6860, 6873,    0, 6886, 6899, 5196, 5193, 6912, 6925, 6938,
        0, 5224, 5230,  262,  229, 5231, 6951, 6964, 5255, 6977,

     6990, 5262, 7003, 7016, 5269, 7029, 5915, 5922, 7042, 5929,
     5977, 7055, 5984, 6018, 5997,  235,  214, 5197, 6015, 7068,
        0,    0, 7081,    0, 6028, 6025, 7094, 7107,    0,    0,
     7120,    0, 6054, 6054, 7133, 7146,    0,    0, 7159,    0,
     6067, 6111, 6115,    3,   91,  230, 6119, 6123, 6153, 6147,
     7172,  268,  279,  302, 6161, 6183, 6192, 6187, 6258,  309,
      386,  434, 6262, 6266, 6498, 6279, 6501,    0,  199, 6494,
     6556,    0, 6562, 6569, 6592, 6601, 6607, 6628, 6636, 6643,
     6690, 1306, 6696, 6702, 6706, 6726, 6732, 6738, 6742, 6762,
     6768, 6844, 7185, 6778, 6851, 6837, 7191, 7197, 6772, 7203,

     7207, 7211, 7215, 7219, 7223, 8542, 7231, 7239, 7247, 7255,
     7263, 7271, 7279, 7284, 7291, 7299, 7307, 7315, 7322, 7330,
     7338, 7346, 7354, 7362, 7369,  218, 7376, 7384, 7392, 7400,
      165, 7408, 7416, 7423, 7431, 7439, 7447, 7455,  159, 7463,
     7471, 7476, 7483, 7491, 7498,  106, 7505, 7513, 7521,   68,
     7529, 7537, 7545, 7553, 7561, 7569, 7577, 7585, 7593, 7601,
     7609, 7617, 7625, 7633, 7641, 7649, 7654, 7661, 7669, 7677,
       66, 7685, 7693, 7701, 7709, 7717, 7725, 7733, 7741, 7749,
     7757, 7765, 7773, 7781, 7789, 7797, 7805, 7813, 7821, 7826,
     7833, 7841, 7849, 7857, 7865, 7873, 7881, 7889, 7897, 7905,

     7913, 7921, 7929, 7937, 7945, 7953, 7961, 7969, 7977, 7985,
     7993, 8001, 8009, 8017, 8025, 8033, 8041, 8046, 8053, 8061,
     8069, 8077, 8085, 8093, 8101, 8109, 8117, 8125, 8133, 8141,
     8149, 8157, 8165, 8173, 8181, 8189, 8197, 8205, 8213, 8221,
     8229, 8237, 8245, 8250, 8257, 8265, 8273, 8281, 8289, 8297,
     8305, 8313, 8321, 8329, 8337, 8345, 8353, 8361, 8369, 8377,
     8385, 8393, 8401, 8409, 8417, 8425, 8433, 8441, 8449, 8454,
     8461, 8469, 8477, 8485, 8493, 8501, 8509, 8517, 8525, 8533
    } ;

static const short int yy_def[1181] =
    {   0,
     1007, 1007, 1006,    3, 1008, 1008, 1008,    7,    7,    7,
        7,    7,    7,    7,    7,    7, 1009, 1009,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7, 1010, 1010,    7,    7,    7,    7, 1011, 1011,
     1011, 1011,    7,    7, 1006, 1012, 1012, 1006, 1013, 1006,
     1006, 1014, 1015, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006,   74, 1006, 1006, 1006, 1006, 1006,
     1006, 1016, 1006, 1017, 1016, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,

     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1018,
     1019, 1018, 1006, 1006, 1006, 1006, 1006, 1006, 1020, 1020,
     1006, 1021, 1020, 1006, 1006, 1006, 1006, 1012, 1012, 1006,
     1013, 1006, 1022, 1013, 1013, 1013, 1013, 1006, 1015, 1014,
     1015, 1015, 1015, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1006, 1006, 1006, 1006,   69, 1006,
     1006, 1023, 1006, 1006, 1006,   75, 1006, 1024, 1025, 1006,
     1026, 1006,   81, 1006, 1006, 1027, 1016, 1017, 1017, 1016,
     1006, 1006, 1006, 1006,   91, 1006, 1006, 1028, 1006,   94,
     1006, 1006, 1029, 1006,   97, 1006, 1006, 1030, 1006, 1006,

     1006, 1006, 1006, 1031, 1006,  109, 1006, 1006, 1032, 1033,
     1034, 1034, 1033, 1006, 1006, 1006, 1006, 1035, 1006, 1006,
     1006, 1006, 1036, 1037, 1037, 1038, 1038, 1038, 1038, 1006,
     1006, 1039, 1040, 1040, 1040, 1041, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1006, 1006, 1006, 1006, 1006,
     1006, 1043, 1043,  253,  253,  253,  253, 1006, 1006, 1006,
     1006, 1044, 1044, 1044, 1044, 1044,  266, 1045, 1046, 1006,
     1006, 1006, 1006, 1047, 1047,  275,  275,  275,  275, 1006,
     1006, 1006, 1006, 1006, 1028,  285,  285,  285,  285,  285,
     1006, 1006, 1006, 1006, 1029,  295,  295,  295,  295,  295,

     1006, 1006, 1006, 1006, 1030,  305,  305,  305,  305,  305,
     1006, 1031, 1006, 1006, 1006, 1006, 1032,  317,  317,  317,
      317,  317, 1006, 1006, 1006, 1006, 1035,  327,  327,  327,
      327,  327, 1006, 1006, 1006, 1006, 1036,  337,  337,  337,
      337,  337, 1039, 1041, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1006, 1006, 1006, 1006, 1006, 1006, 1048,  253,  359,
     1006, 1049, 1006, 1006, 1050,  266, 1006, 1006, 1006, 1006,
     1051,  275,  372, 1006, 1052, 1006, 1006, 1006, 1006, 1006,
      285, 1006, 1006, 1006, 1006, 1053, 1054, 1054, 1006, 1055,
     1006, 1006, 1006, 1006, 1056, 1057, 1057, 1006, 1058, 1006,

     1006, 1006, 1006, 1006, 1006, 1059, 1060, 1060, 1006, 1061,
     1006, 1006, 1006, 1062, 1006, 1006, 1006, 1006, 1063, 1064,
     1064, 1006, 1065, 1066, 1067, 1067, 1067, 1067, 1067, 1067,
     1006, 1006, 1006, 1006, 1006, 1068, 1068,  437,  437,  437,
      437, 1069, 1069,  443,  443, 1070, 1006, 1006, 1006, 1070,
      450,  450,  450,  450,  450, 1071, 1006,  457,  457, 1006,
     1006, 1006, 1006, 1072, 1072,  465,  465,  465,  465, 1073,
     1073,  471,  471, 1074, 1006, 1006, 1006, 1074,  478,  478,
      478,  478,  478, 1006, 1075, 1006, 1006, 1006, 1006, 1076,
     1076,  491,  491,  491,  491, 1077, 1077,  497,  497, 1078,

     1006, 1006, 1006, 1078,  504,  504,  504,  504,  504, 1006,
     1006, 1006, 1006, 1079, 1079,  515,  515,  515,  515, 1080,
     1080,  521,  521, 1081, 1006, 1006, 1006, 1081,  528,  528,
      528,  528,  528, 1006, 1006, 1006, 1006, 1082, 1082,  539,
      539,  539,  539, 1083, 1083,  545,  545, 1084, 1006, 1006,
     1006, 1084,  552,  552,  552,  552,  552, 1006, 1085, 1006,
     1006, 1006, 1006, 1086, 1086,  565,  565,  565,  565, 1087,
     1087,  571,  571, 1088, 1006, 1006, 1006, 1088,  578,  578,
      578,  578,  578, 1089, 1090, 1090, 1090, 1090, 1006, 1006,
     1006, 1091, 1092, 1092,  594,  594, 1006, 1093, 1006, 1006,

     1006, 1006, 1094, 1095, 1095, 1006, 1096, 1097, 1097,  609,
      609,  611, 1006, 1098, 1006, 1096, 1099, 1099, 1098, 1006,
     1006, 1100, 1100,  623, 1006, 1006, 1006, 1101, 1102, 1102,
      630,  630, 1006, 1103, 1006, 1006, 1006, 1104, 1105, 1105,
      640,  640, 1006, 1106, 1006, 1006, 1006, 1006, 1107, 1108,
     1108, 1006, 1109, 1110, 1110,  655,  655,  657, 1006, 1111,
     1006, 1109, 1112, 1112, 1111, 1006, 1006, 1113, 1113,  669,
     1006, 1006, 1006, 1114, 1115, 1115,  676,  676, 1006, 1116,
     1117, 1117, 1118, 1118, 1118, 1118, 1006, 1119, 1120, 1006,
     1121, 1006, 1006, 1006, 1006, 1122, 1122,  697,  697,  697,

      697, 1123, 1123,  703,  703, 1006, 1006, 1006, 1124, 1124,
      710,  710,  710,  710, 1125, 1125,  716,  716, 1126, 1006,
     1006, 1006, 1126,  723,  723,  723,  723,  723, 1006, 1127,
     1127,  731,  731, 1006, 1128, 1129, 1006, 1130, 1006, 1131,
     1132, 1006, 1133, 1006, 1006, 1006, 1006, 1134, 1134,  749,
      749,  749,  749, 1135, 1135,  755,  755, 1006, 1006, 1006,
     1136, 1136,  762,  762,  762,  762, 1137, 1137,  768,  768,
     1138, 1006, 1006, 1006, 1138,  775,  775,  775,  775,  775,
     1006, 1139, 1139,  783,  783, 1006, 1140, 1141, 1006, 1142,
     1143, 1143, 1144, 1144, 1144, 1006, 1006, 1145, 1145,  799,

     1146, 1146,  802, 1006, 1006, 1147, 1147,  807, 1006, 1006,
     1006, 1148, 1149, 1149,  814,  814, 1006, 1150, 1151, 1151,
      820,  820, 1006, 1152, 1006, 1006, 1153, 1153,  828,  828,
     1006, 1006, 1154, 1154,  834, 1155, 1155,  837, 1006, 1006,
     1156, 1156,  842, 1006, 1006, 1157, 1157,  847, 1158, 1158,
      850, 1006, 1006, 1159, 1159,  855, 1006, 1006, 1006, 1160,
     1161, 1161,  862,  862, 1006, 1162, 1163, 1163,  868,  868,
     1006, 1164, 1006, 1006, 1165, 1165,  876,  876, 1006, 1006,
     1166, 1166,  882, 1167, 1167,  885, 1006, 1006, 1168, 1168,
      890, 1169, 1169, 1170, 1170, 1006, 1171, 1172, 1006, 1173,

     1174, 1006, 1175, 1176, 1006, 1160,  862, 1006, 1162,  868,
     1006, 1164,  876, 1169, 1169, 1170, 1170, 1006, 1006, 1171,
      920,  920, 1172,  923,  923, 1006, 1006, 1173,  928,  928,
     1174,  931,  931, 1006, 1006, 1175,  936,  936, 1176,  939,
      939, 1006, 1006,  906,  906,  906,  862,  862,  864, 1006,
     1006,  909,  909,  909,  868,  868,  870, 1006,  874,  912,
      912,  912,  876,  876,  878, 1169, 1169, 1170, 1170, 1169,
     1169, 1170, 1169, 1169, 1169, 1169, 1169, 1177, 1169, 1177,
     1177, 1006, 1177, 1169, 1006, 1178, 1169, 1178, 1178, 1178,
     1169, 1169, 1169, 1169, 1169, 1179, 1179, 1179, 1006, 1179,

     1006, 1180, 1180, 1180, 1180,    0, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,

     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006
    } ;

static const short int yy_nxt[8592] =
    {   0,
     1006,   47,   48,   47, 1006, 1006,   49,   47,   48,   47,
      748,  751,   49,   50,   51,   48,   51,   52,   50,   53,
       52,   52,   50,   50,   50,   50,   50,   52,   52,   54,
       55,   52,   56,   52,   52,   57,   52,   58,   59,   52,
       60,   61,   52,   52,   50,   50,   50,   52,   52,   62,
       63,   52,   52,   52,   52,   52,   52,   52,   52,   52,
       52,   52,   51,   48,   51,  152,  153,   53,   51,   48,
       51,  586,  456,   53,  456,  587,  129,  130,  129,   64,
       65,  131,  132, 1006,  132,   64,   65,  133,   66,  158,
      159,  159,  159,  159,   66,   51,   48,   51,  748,  751,

       53, 1006,   67,   68,   69,   69,   69,   69,  160,  160,
      160,  160,  269,   65,   70,   71,   72,   72,   72,   72,
       70,   71,   72,   72,   72,   72,   73,   50,   74,   75,
       75,   75,   73,   50,   74,   75,   75,   75,   76,   50,
       77,   78,   78,   78,   76,   50,   77,   78,   78,   78,
       79,   80,   81,   81,   81,   81,   79,   80,   81,   81,
       81,   81,   51,   48,   51,  343,   83,   84,   51,   48,
       51,  312,   83,   84,   86,   87,   88,   88,   88,   88,
       85,  163,  164,  164,  164,  164,   85,   86,   87,   88,
       88,   88,   88,   89,   90,   91,   91,   91,   91,   89,

       90,   91,   91,   91,   91,   92,   93,   94,   94,   94,
       94,   92,   93,   94,   94,   94,   94,   95,   96,   97,
       97,   97,   97,  262,  269,  120,   48,  120,   98,  121,
      122,  120,   48,  120,  972,  121,  122,  748,  751,  262,
       99,  262,  100,   95,   96,   97,   97,   97,   97,  262,
      138,  130,  138,  969,   98,  139,  123,  262,  968,  120,
       48,  120,  123,  124,  122,  917,   99,  262,  100,  101,
      102,  103,  103,  103,  103,  761,  764,  120,   48,  120,
       98,  124,  122,  135,  130,  135,  761,  764,  136,  916,
      123,  895,   99,  894,  100,  101,  102,  103,  103,  103,

      103,  795,  142,  130,  142,  794,   98,  143,  123,  761,
      764,  137,  165,  165,  165,  165,  775,  778,   99,  793,
      100,  104,   50,  105,  106,  106,  106,  163,  164,  164,
      164,  164,   98,  686,  125,   50,  126,  127,  127,  127,
      166,  166,  166,  166,   99,   50,  100,  104,   50,  105,
      106,  106,  106,  170,  170,  170,  170,  685,   98,  684,
      125,   50,  126,  127,  127,  127,  170,  170,  170,  170,
       99,   50,  100,  107,  108,  109,  109,  109,  109,  172,
      173,  173,  173,  173,   98,  170,  170,  170,  170,  174,
      174,  174,  174,  775,  778,  683,   99,  588,  100,  107,

      108,  109,  109,  109,  109,  171,  585,  142,  130,  142,
       98,  141,  179,  181,  182,  182,  182,  182,  183,  183,
      183,  183,   99,  171,  100,   51,   48,   51,  431,   83,
      111,  181,  182,  182,  182,  182,  184,  185,  185,  185,
      185,  775,  778,  112,  186,  186,  186,  186,  189,  190,
      190,  190,  190,  430,  429,   99,  428,  100,   51,   48,
       51,  427,   83,  111,  191,  191,  191,  191,  194,  195,
      195,  195,  195,  426,  425,  353,  112,  196,  196,  196,
      196,  200,  201,  201,  201,  201,  352,  351,   99,  350,
      100,  113,  114,  115,  115,  115,  115,  202,  202,  202,

      202,  349,   98,  200,  201,  201,  201,  201,  203,  203,
      203,  203,  348,  347,   99,  346,  100,  113,  114,  115,
      115,  115,  115,  203,  203,  203,  203,  345,   98,  203,
      203,  203,  203,  205,  206,  206,  206,  206,  247,  246,
       99,  245,  100,  116,  117,  118,  118,  118,  118,  204,
      207,  207,  207,  207,   98,  142,  130,  142,  244,  141,
      212,  214,  215,  215,  215,  215,   99,  204,  100,  116,
      117,  118,  118,  118,  118,  216,  216,  216,  216,  243,
       98,  221,  221,  221,  221,  141,  242,  141,  225,  130,
      225,  241,   99,  226,  100,  161,  161,  161,  240,  239,

      162,  238,  237,  158,  159,  159,  159,  159,  167,  167,
      167,  230,  213,  168,  199,  180,  157,  166,  166,  166,
      166,  219,  220,  220,  220,  220,  228,  130,  228,  156,
      141,  229,  231,  231,  231,  231,  155,  169,  231,  231,
      231,  231,  129,  130,  129,  154,  132,  131,  132,  151,
      150,  133,  149,  148,  147,  169,  175,  175,  175,  146,
      145,  176,  144, 1006,  172,  173,  173,  173,  173,  187,
      187,  187, 1006, 1006,  188, 1006, 1006,  184,  185,  185,
      185,  185,  192,  192,  192, 1006, 1006,  193, 1006, 1006,
      189,  190,  190,  190,  190,  197,  197,  197, 1006, 1006,

      198, 1006, 1006,  194,  195,  195,  195,  195,  208,  208,
      208, 1006, 1006,  209, 1006, 1006,  205,  206,  206,  206,
      206,  217,  217,  217, 1006, 1006,  218, 1006, 1006,  214,
      215,  215,  215,  215,  222,  222,  222, 1006, 1006,  223,
     1006, 1006,  219,  220,  220,  220,  220,  231,  231,  231,
      231,  135,  130,  135, 1006,  132,  136,  132, 1006,  234,
      133,  234, 1006, 1006,  235, 1006, 1006,  232,  135,  130,
      135, 1006, 1006,  136,  135,  130,  135, 1006, 1006,  136,
     1006,  135,  130,  135, 1006,  232,  136,  135,  130,  135,
     1006, 1006,  136,  138,  130,  138, 1006, 1006,  139,  142,

      130,  142, 1006, 1006,  143,  142,  130,  142, 1006, 1006,
      143,  236,  142,  130,  142, 1006, 1006,  143,  142,  130,
      142, 1006, 1006,  143,  160,  160,  160,  160,  161,  161,
      161, 1006, 1006,  162, 1006, 1006, 1006,  160,  160,  160,
      160, 1006, 1006, 1006,  248,  165,  165,  165,  165,  163,
      164,  164,  164,  164,  165,  165,  165,  165, 1006, 1006,
     1006,  258, 1006,  248,  161,  161,  161, 1006, 1006,  162,
     1006,  249,  250,  251,  251,  251,  251,  253,  161,  253,
      258, 1006,  254, 1006,  255,  256,  257,  257,  257,  257,
      167,  167,  167, 1006, 1006,  168, 1006,  259, 1006,  260,

      261,  261,  261,  263,  167,  263, 1006, 1006,  264, 1006,
      265, 1006,  266,  267,  267,  267,  167,  167,  167, 1006,
     1006,  168,  170,  170,  170,  170,  174,  174,  174,  174,
      175,  175,  175, 1006, 1006,  176, 1006, 1006, 1006,  174,
      174,  174,  174,  142,  130,  142,  270,  141,  179,  142,
      130,  142, 1006,  141,  179,  183,  183,  183,  183,  181,
      182,  182,  182,  182, 1006,  270,  175,  175,  175, 1006,
     1006,  176, 1006,  271,  272,  273,  273,  273,  273,  275,
      175,  275, 1006, 1006,  276, 1006,  277,  278,  279,  279,
      279,  279,  183,  183,  183,  183, 1006, 1006, 1006,  280,

      186,  186,  186,  186,  191,  191,  191,  191,  196,  196,
      196,  196,  202,  202,  202,  202, 1006, 1006,  280,  187,
      187,  187, 1006, 1006,  188, 1006, 1006, 1006,  186,  186,
      186,  186, 1006, 1006, 1006,  281,  200,  201,  201,  201,
      201,  203,  203,  203,  203,  202,  202,  202,  202, 1006,
     1006, 1006,  311, 1006,  281,  187,  187,  187, 1006, 1006,
      188, 1006,  282,  283,  284,  284,  284,  284,  286,  187,
      286,  311, 1006,  287, 1006,  288,  289,  290,  290,  290,
      290,  192,  192,  192, 1006, 1006,  193, 1006, 1006, 1006,
      191,  191,  191,  191, 1006, 1006, 1006,  291,  207,  207,

      207,  207, 1006, 1006,  142,  130,  142, 1006,  141,  212,
      216,  216,  216,  216, 1006, 1006,  291,  192,  192,  192,
     1006, 1006,  193, 1006,  292,  293,  294,  294,  294,  294,
      296,  192,  296, 1006,  141,  297,  141,  298,  299,  300,
      300,  300,  300,  197,  197,  197, 1006, 1006,  198, 1006,
     1006, 1006,  196,  196,  196,  196, 1006, 1006, 1006,  301,
      221,  221,  221,  221, 1006, 1006,  142,  130,  142, 1006,
      141,  212,  225,  130,  225, 1006, 1006,  226,  301,  197,
      197,  197, 1006, 1006,  198, 1006,  302,  303,  304,  304,
      304,  304,  306,  197,  306, 1006,  141,  307,  141,  308,

      309,  310,  310,  310,  310,  208,  208,  208, 1006, 1006,
      209, 1006, 1006, 1006,  207,  207,  207,  207,  228,  130,
      228,  313,  141,  229,  228,  130,  228, 1006,  141,  229,
      228,  130,  228, 1006,  141,  229,  231,  231,  231,  231,
      313,  208,  208,  208, 1006, 1006,  209, 1006,  314,  315,
      316,  316,  316,  316,  318,  208,  318, 1006, 1006,  319,
     1006,  320,  321,  322,  322,  322,  322,  217,  217,  217,
     1006, 1006,  218, 1006, 1006,  214,  215,  215,  215,  215,
      217,  217,  217, 1006, 1006,  218, 1006, 1006, 1006,  216,
      216,  216,  216,  228,  130,  228,  323,  141,  229,  234,

      234,  234,  234, 1006,  235,  235,  234,  985,  234,  985,
     1006,  235,  986, 1006, 1006,  323,  217,  217,  217, 1006,
     1006,  218, 1006,  324,  325,  326,  326,  326,  326,  328,
      217,  328, 1006, 1006,  329, 1006,  330,  331,  332,  332,
      332,  332,  222,  222,  222, 1006, 1006,  223, 1006, 1006,
      219,  220,  220,  220,  220,  222,  222,  222, 1006, 1006,
      223, 1006, 1006, 1006,  221,  221,  221,  221,  135,  130,
      135,  333, 1006,  136,  354,  354, 1006,  355,  355,  355,
      355,  250,  251,  251,  251,  251, 1006, 1006,  344, 1006,
      333,  222,  222,  222, 1006, 1006,  223, 1006,  334,  335,

      336,  336,  336,  336,  338,  222,  338, 1006, 1006,  339,
     1006,  340,  341,  342,  342,  342,  342,  356,  356,  356,
      356,  357,  357,  357, 1006, 1006,  358, 1006, 1006,  250,
      251,  251,  251,  251,  253,  161,  253, 1006, 1006,  254,
     1006,  255,  256,  257,  257,  257,  257,  253,  161,  253,
     1006, 1006,  254, 1006,  255,  256,  257,  257,  257,  257,
      359,  359,  359,  359,  360,  361,  360,  363,  363,  362,
      364,  364,  364,  364,  261,  261,  261,  261,  261,  261,
      261,  261,  261,  261,  261,  261,  167,  167,  167,  367,
      367,  168,  368,  368,  368,  368, 1006, 1006,  365,  272,

      273,  273,  273,  273,  369,  369,  369,  369,  372,  372,
      372,  372,  380,  380,  380,  380,  365,  263,  167,  263,
     1006, 1006,  264, 1006,  265, 1006,  266,  267,  267,  267,
      263,  167,  263, 1006, 1006,  264, 1006,  265, 1006,  266,
      267,  267,  267,  263,  167,  263, 1006, 1006,  264, 1006,
      265, 1006,  266,  267,  267,  267,  263,  167,  263, 1006,
     1006,  264, 1006,  265, 1006,  266,  267,  267,  267,  263,
      167,  263, 1006, 1006,  264, 1006,  265, 1006,  266,  267,
      267,  267,  373,  374,  373,  376,  376,  375,  377,  377,
      377,  377,  381,  381,  381,  381,  378,  378,  366,  379,

      379,  379,  379,  283,  284,  284,  284,  284,  283,  284,
      284,  284,  284, 1006, 1006, 1006,  366,  370,  370,  370,
     1006, 1006,  371, 1006, 1006,  272,  273,  273,  273,  273,
      275,  175,  275, 1006, 1006,  276, 1006,  277,  278,  279,
      279,  279,  279,  275,  175,  275, 1006, 1006,  276, 1006,
      277,  278,  279,  279,  279,  279,  286,  187,  286, 1006,
     1006,  287, 1006,  288,  289,  290,  290,  290,  290,  382,
      382, 1006,  383,  383,  383,  383,  293,  294,  294,  294,
      294,  384,  384,  384,  384,  385,  385,  385, 1006, 1006,
      386, 1006, 1006,  293,  294,  294,  294,  294,  296,  192,

      296, 1006, 1006,  297, 1006,  298,  299,  300,  300,  300,
      300,  387,  387,  387,  387,  388,  389,  388,  391,  391,
      390,  392,  392,  392,  392,  303,  304,  304,  304,  304,
      393,  393,  393,  393,  394,  394,  394, 1006, 1006,  395,
     1006, 1006,  303,  304,  304,  304,  304,  306,  197,  306,
     1006, 1006,  307, 1006,  308,  309,  310,  310,  310,  310,
      396,  396,  396,  396,  397,  398,  397,  400,  400,  399,
      401,  401,  401,  401,  402,  402, 1006,  403,  403,  403,
      403,  315,  316,  316,  316,  316,  404,  404,  404,  404,
      405,  405,  405, 1006, 1006,  406, 1006, 1006,  315,  316,

      316,  316,  316,  318,  208,  318, 1006, 1006,  319, 1006,
      320,  321,  322,  322,  322,  322,  407,  407,  407,  407,
      408,  409,  408,  411,  411,  410,  412,  412,  412,  412,
      325,  326,  326,  326,  326,  413,  413,  413,  413,  325,
      326,  326,  326,  326,  328,  217,  328, 1006, 1006,  329,
     1006,  330,  331,  332,  332,  332,  332,  414,  414,  414,
      414,  415,  415, 1006,  416,  416,  416,  416,  335,  336,
      336,  336,  336,  417,  417,  417,  417,  418,  418,  418,
     1006, 1006,  419, 1006, 1006,  335,  336,  336,  336,  336,
      338,  222,  338, 1006, 1006,  339, 1006,  340,  341,  342,

      342,  342,  342,  420,  420,  420,  420,  421,  422,  421,
     1006, 1006,  423,  135,  130,  135, 1006, 1006,  136,  355,
      355,  355,  355,  364,  364,  364,  364,  364,  364,  364,
      364, 1006,  424,  161,  161,  161, 1006, 1006,  162, 1006,
     1006, 1006,  355,  355,  355,  355,  357,  357,  357, 1006,
     1006,  358, 1006, 1006, 1006,  356,  356,  356,  356, 1006,
     1006, 1006,  432,  368,  368,  368,  368,  377,  377,  377,
      377,  377,  377,  377,  377,  379,  379,  379,  379, 1006,
     1006,  432,  357,  357,  357, 1006, 1006,  358, 1006,  433,
      434,  435,  435,  435,  435,  437,  357,  437, 1006, 1006,

      438, 1006,  439,  440,  441,  441,  441,  441,  360,  361,
      360, 1006, 1006,  362, 1006, 1006, 1006,  359,  359,  359,
      359, 1006, 1006, 1006,  442,  380,  380,  380,  380, 1006,
     1006, 1006,  484,  381,  381,  381,  381,  135,  130,  584,
      485, 1006,  136,  442,  443,  444,  445,  445,  445,  445,
     1006,  484, 1006,  252,  383,  383,  383,  383, 1006,  485,
      392,  392,  392,  392,  401,  401,  401,  401,  401,  401,
      401,  401,  252,  361,  361,  361, 1006, 1006,  446, 1006,
      447,  448,  449,  449,  449,  449,  451,  361,  451, 1006,
     1006,  452, 1006,  453,  454,  455,  455,  455,  455,  457,

      458,  458,  458,  459,  459,  459,  459,  459,  403,  403,
      403,  403,  412,  412,  412,  412,  360,  361,  360,  262,
     1006,  362, 1006,  459,  459,  459,  459, 1006,  413,  413,
      413,  413, 1006, 1006, 1006,  558, 1006,  262,  175,  175,
      175, 1006, 1006,  176, 1006, 1006, 1006,  368,  368,  368,
      368,  370,  370,  370,  558, 1006,  371, 1006, 1006, 1006,
      369,  369,  369,  369, 1006, 1006, 1006,  460,  416,  416,
      416,  416,  589,  589, 1006,  590,  590,  590,  590,  434,
      435,  435,  435,  435, 1006, 1006,  460,  370,  370,  370,
     1006, 1006,  371, 1006,  461,  462,  463,  463,  463,  463,

      465,  370,  465, 1006, 1006,  466, 1006,  467,  468,  469,
      469,  469,  469,  373,  374,  373, 1006, 1006,  375, 1006,
     1006, 1006,  372,  372,  372,  372, 1006, 1006, 1006,  470,
      591,  591,  591,  591,  434,  435,  435,  435,  435,  592,
      592,  592,  592,  256,  596,  596,  596,  596,  470,  471,
      472,  473,  473,  473,  473, 1006, 1006, 1006,  274,  448,
      449,  449,  449,  449,  597,  597,  597,  597,  598,  598,
      598,  598,  462,  463,  463,  463,  463,  274,  374,  374,
      374, 1006, 1006,  474, 1006,  475,  476,  477,  477,  477,
      477,  479,  374,  479, 1006, 1006,  480, 1006,  481,  482,

      483,  483,  483,  483,  187,  187,  187, 1006, 1006,  188,
     1006, 1006, 1006,  379,  379,  379,  379,  192,  192,  192,
     1006, 1006,  193, 1006, 1006, 1006,  383,  383,  383,  383,
      385,  385,  385, 1006, 1006,  386, 1006, 1006, 1006,  384,
      384,  384,  384, 1006,  599,  599,  486,  600,  600,  600,
      600,  601,  601,  601,  601,  604,  604,  604,  604,  605,
      606,  605, 1006, 1006,  607,  486,  385,  385,  385, 1006,
     1006,  386, 1006,  487,  488,  489,  489,  489,  489,  491,
      385,  491, 1006, 1006,  492, 1006,  493,  494,  495,  495,
      495,  495,  388,  389,  388, 1006, 1006,  390, 1006,  298,

      299,  387,  387,  387,  387, 1006, 1006, 1006,  496,  278,
      611,  611,  611,  611,  612,  613,  612, 1006, 1006,  614,
      476,  477,  477,  477,  477, 1006, 1006,  496,  388,  389,
      388, 1006, 1006,  390, 1006,  497,  498,  499,  499,  499,
      499,  389,  389,  389, 1006, 1006,  500, 1006,  501,  502,
      503,  503,  503,  503,  505,  389,  505, 1006, 1006,  506,
     1006,  507,  508,  509,  509,  509,  509,  197,  197,  197,
     1006, 1006,  198, 1006, 1006, 1006,  392,  392,  392,  392,
      394,  394,  394, 1006, 1006,  395, 1006, 1006, 1006,  393,
      393,  393,  393, 1006, 1006, 1006,  510,  615,  615,  615,

      615,  617,  617,  617,  617,  618,  613,  618,  620,  620,
      619,  621,  621,  621,  621,  510,  394,  394,  394, 1006,
     1006,  395, 1006,  511,  512,  513,  513,  513,  513,  515,
      394,  515, 1006, 1006,  516, 1006,  517,  518,  519,  519,
      519,  519,  397,  398,  397, 1006, 1006,  399, 1006,  308,
      309,  396,  396,  396,  396, 1006,  625,  625,  520,  626,
      626,  626,  626,  488,  489,  489,  489,  489,  627,  627,
      627,  627,  488,  489,  489,  489,  489,  520,  397,  398,
      397, 1006, 1006,  399, 1006,  521,  522,  523,  523,  523,
      523,  398,  398,  398, 1006, 1006,  524, 1006,  525,  526,

      527,  527,  527,  527,  529,  398,  529, 1006, 1006,  530,
     1006,  531,  532,  533,  533,  533,  533,  208,  208,  208,
     1006, 1006,  209, 1006, 1006, 1006,  403,  403,  403,  403,
      405,  405,  405, 1006, 1006,  406, 1006, 1006, 1006,  404,
      404,  404,  404, 1006, 1006, 1006,  534,  628,  628,  628,
      628,  299,  632,  632,  632,  632,  388,  389,  388, 1006,
     1006,  390, 1006, 1006, 1006,  534,  405,  405,  405, 1006,
     1006,  406, 1006,  535,  536,  537,  537,  537,  537,  539,
      405,  539, 1006, 1006,  540, 1006,  541,  542,  543,  543,
      543,  543,  408,  409,  408, 1006, 1006,  410, 1006,  320,

      321,  407,  407,  407,  407, 1006, 1006, 1006,  544,  502,
      503,  503,  503,  503,  633,  633,  633,  633,  634,  634,
      634,  634,  512,  513,  513,  513,  513,  544,  408,  409,
      408, 1006, 1006,  410, 1006,  545,  546,  547,  547,  547,
      547,  409,  409,  409, 1006, 1006,  548, 1006,  549,  550,
      551,  551,  551,  551,  553,  409,  553, 1006, 1006,  554,
     1006,  555,  556,  557,  557,  557,  557,  217,  217,  217,
     1006, 1006,  218, 1006, 1006, 1006,  412,  412,  412,  412,
      328,  217,  328, 1006, 1006,  329, 1006,  330,  331,  414,
      414,  414,  414, 1006,  635,  635,  559,  636,  636,  636,

      636,  637,  637,  637,  637,  512,  513,  513,  513,  513,
      638,  638,  638,  638, 1006,  559,  222,  222,  222, 1006,
     1006,  223, 1006, 1006, 1006,  416,  416,  416,  416,  418,
      418,  418, 1006, 1006,  419, 1006, 1006, 1006,  417,  417,
      417,  417, 1006, 1006, 1006,  560,  309,  642,  642,  642,
      642,  397,  398,  397, 1006, 1006,  399,  526,  527,  527,
      527,  527, 1006, 1006,  560,  418,  418,  418, 1006, 1006,
      419, 1006,  561,  562,  563,  563,  563,  563,  565,  418,
      565, 1006, 1006,  566, 1006,  567,  568,  569,  569,  569,
      569,  421,  422,  421, 1006, 1006,  423, 1006,  340,  341,

      420,  420,  420,  420, 1006, 1006, 1006,  570,  643,  643,
      643,  643,  644,  644,  644,  644,  645,  645, 1006,  646,
      646,  646,  646, 1006, 1006, 1006,  570,  421,  422,  421,
     1006, 1006,  423, 1006,  571,  572,  573,  573,  573,  573,
      422,  422,  422, 1006, 1006,  574, 1006,  575,  576,  577,
      577,  577,  577,  579,  422,  579, 1006, 1006,  580, 1006,
      581,  582,  583,  583,  583,  583,  437,  357,  437, 1006,
     1006,  438, 1006,  439,  440,  441,  441,  441,  441,  437,
      357,  437, 1006, 1006,  438, 1006,  439,  440,  441,  441,
      441,  441,  253,  161,  253, 1006, 1006,  254,  593,  594,

      256,  595,  595,  595,  595,  253,  161,  253, 1006, 1006,
      254, 1006,  255,  444,  445,  445,  445,  445,  451,  361,
      451, 1006, 1006,  452, 1006,  453,  454,  455,  455,  455,
      455,  357,  357,  357, 1006, 1006,  358, 1006, 1006,  448,
      449,  449,  449,  449,  451,  361,  451, 1006, 1006,  452,
     1006,  453,  454,  455,  455,  455,  455,  262,  263,  167,
      263,  262,  262,  264,  262,  265,  262,  457,  458,  458,
      458,  459,  459,  459,  459,  459,  262,  262,  262,  262,
      262,  262,  262,  262,  262,  262,  262,  366,  262,  262,
      262,  459,  459,  459,  459,  262,  262,  262,  262,  262,

      262,  262,  262,  262,  262,  366,  602,  602,  602, 1006,
     1006,  603, 1006, 1006,  462,  463,  463,  463,  463,  465,
      370,  465, 1006, 1006,  466, 1006,  467,  468,  469,  469,
      469,  469,  465,  370,  465, 1006, 1006,  466, 1006,  467,
      468,  469,  469,  469,  469,  275,  175,  275, 1006, 1006,
      276,  608,  609,  278,  610,  610,  610,  610,  275,  175,
      275, 1006, 1006,  276, 1006,  277,  472,  473,  473,  473,
      473,  479,  374,  479, 1006, 1006,  480, 1006,  481,  482,
      483,  483,  483,  483,  606,  606,  606, 1006, 1006,  616,
     1006, 1006,  476,  477,  477,  477,  477,  479,  374,  479,

     1006, 1006,  480, 1006,  481,  482,  483,  483,  483,  483,
      286,  187,  286, 1006, 1006,  287,  622,  623,  289,  624,
      624,  624,  624,  491,  385,  491, 1006, 1006,  492, 1006,
      493,  494,  495,  495,  495,  495,  491,  385,  491, 1006,
     1006,  492, 1006,  493,  494,  495,  495,  495,  495,  296,
      192,  296, 1006, 1006,  297,  629,  630,  299,  631,  631,
      631,  631,  296,  192,  296, 1006, 1006,  297, 1006,  298,
      498,  499,  499,  499,  499,  505,  389,  505, 1006, 1006,
      506, 1006,  507,  508,  509,  509,  509,  509,  385,  385,
      385, 1006, 1006,  386, 1006, 1006,  502,  503,  503,  503,

      503,  505,  389,  505, 1006, 1006,  506, 1006,  507,  508,
      509,  509,  509,  509,  515,  394,  515, 1006, 1006,  516,
     1006,  517,  518,  519,  519,  519,  519,  515,  394,  515,
     1006, 1006,  516, 1006,  517,  518,  519,  519,  519,  519,
      306,  197,  306, 1006, 1006,  307,  639,  640,  309,  641,
      641,  641,  641,  306,  197,  306, 1006, 1006,  307, 1006,
      308,  522,  523,  523,  523,  523,  529,  398,  529, 1006,
     1006,  530, 1006,  531,  532,  533,  533,  533,  533,  394,
      394,  394, 1006, 1006,  395, 1006, 1006,  526,  527,  527,
      527,  527,  529,  398,  529, 1006, 1006,  530, 1006,  531,

      532,  533,  533,  533,  533,  536,  537,  537,  537,  537,
      647,  647,  647,  647,  648,  648,  648, 1006, 1006,  649,
     1006, 1006,  536,  537,  537,  537,  537,  539,  405,  539,
     1006, 1006,  540, 1006,  541,  542,  543,  543,  543,  543,
      539,  405,  539, 1006, 1006,  540, 1006,  541,  542,  543,
      543,  543,  543,  650,  650,  650,  650,  651,  652,  651,
     1006, 1006,  653,  318,  208,  318, 1006, 1006,  319,  654,
      655,  321,  656,  656,  656,  656,  318,  208,  318, 1006,
     1006,  319, 1006,  320,  546,  547,  547,  547,  547,  321,
      657,  657,  657,  657,  658,  659,  658, 1006, 1006,  660,

      553,  409,  553, 1006, 1006,  554, 1006,  555,  556,  557,
      557,  557,  557,  550,  551,  551,  551,  551,  661,  661,
      661,  661,  652,  652,  652, 1006, 1006,  662, 1006, 1006,
      550,  551,  551,  551,  551,  553,  409,  553, 1006, 1006,
      554, 1006,  555,  556,  557,  557,  557,  557,  663,  663,
      663,  663,  664,  659,  664,  666,  666,  665,  667,  667,
      667,  667,  328,  217,  328, 1006, 1006,  329,  668,  669,
      331,  670,  670,  670,  670,  671,  671, 1006,  672,  672,
      672,  672,  562,  563,  563,  563,  563,  673,  673,  673,
      673,  562,  563,  563,  563,  563,  565,  418,  565, 1006,

     1006,  566, 1006,  567,  568,  569,  569,  569,  569,  565,
      418,  565, 1006, 1006,  566, 1006,  567,  568,  569,  569,
      569,  569,  674,  674,  674,  674,  338,  222,  338, 1006,
     1006,  339,  675,  676,  341,  677,  677,  677,  677,  338,
      222,  338, 1006, 1006,  339, 1006,  340,  572,  573,  573,
      573,  573,  341,  678,  678,  678,  678,  421,  422,  421,
     1006, 1006,  423,  579,  422,  579, 1006, 1006,  580, 1006,
      581,  582,  583,  583,  583,  583,  576,  577,  577,  577,
      577,  679,  679,  679,  679,  418,  418,  418, 1006, 1006,
      419, 1006, 1006,  576,  577,  577,  577,  577,  579,  422,

      579, 1006, 1006,  580, 1006,  581,  582,  583,  583,  583,
      583,  680,  680,  680,  680,  135,  130,  135, 1006, 1006,
      136,  590,  590,  590,  590,  591,  591,  591,  591, 1006,
      681, 1006,  687,  360,  361,  360, 1006, 1006,  362,  600,
      600,  600,  600,  682,  357,  357,  357, 1006, 1006,  358,
     1006,  687, 1006,  590,  590,  590,  590,  437,  357,  437,
     1006, 1006,  438, 1006,  439,  440,  592,  592,  592,  592,
      373,  374,  373,  688, 1006,  375,  621,  621,  621,  621,
      621,  621,  621,  621,  626,  626,  626,  626,  636,  636,
      636,  636,  688,  253,  161,  253, 1006, 1006,  254, 1006,

      255,  256,  595,  595,  595,  595,  253,  161,  253, 1006,
     1006,  254, 1006,  255,  256,  595,  595,  595,  595,  360,
      361,  360, 1006, 1006,  362, 1006, 1006, 1006,  596,  596,
      596,  596, 1006, 1006, 1006,  689,  627,  627,  627,  627,
      388,  389,  388,  734, 1006,  390,  637,  637,  637,  637,
     1006, 1006, 1006,  739,  689,  357,  357,  357, 1006, 1006,
      358, 1006,  734, 1006,  597,  597,  597,  597,  397,  398,
      397,  690,  739,  399,  646,  646,  646,  646,  408,  409,
      408, 1006, 1006,  410,  667,  667,  667,  667, 1006, 1006,
      690,  451,  361,  451, 1006, 1006,  452, 1006,  453,  454,

      598,  598,  598,  598, 1006, 1006, 1006,  691,  667,  667,
      667,  667,  672,  672,  672,  672, 1006,  673,  673,  673,
      673, 1006, 1006, 1006,  786, 1006,  691,  370,  370,  370,
     1006, 1006,  371, 1006, 1006, 1006,  600,  600,  600,  600,
      602,  602,  602,  786, 1006,  603, 1006, 1006, 1006,  601,
      601,  601,  601,  421,  422,  421,  692, 1006,  423,  811,
      811,  811,  811,  135,  130,  135, 1006, 1006,  136,  135,
      130,  135, 1006, 1006,  136,  692,  602,  602,  602, 1006,
      792,  603, 1006,  693,  694,  695,  695,  695,  695,  697,
      602,  697, 1006, 1006,  698, 1006,  699,  700,  701,  701,

      701,  701,  605,  606,  605,  791, 1006,  607, 1006,  467,
      468,  604,  604,  604,  604, 1006,  796,  796,  702,  797,
      797,  797,  797,  804,  804, 1006,  805,  805,  805,  805,
      809,  809, 1006,  810,  810,  810,  810,  702,  605,  606,
      605, 1006, 1006,  607, 1006,  703,  704,  705,  705,  705,
      705,  606,  606,  606, 1006, 1006,  616, 1006,  706,  707,
      708,  708,  708,  708,  710,  606,  710, 1006, 1006,  711,
     1006,  712,  713,  714,  714,  714,  714,  275,  175,  275,
     1006, 1006,  276, 1006,  277,  278,  610,  610,  610,  610,
      275,  175,  275, 1006, 1006,  276, 1006,  277,  278,  610,

      610,  610,  610,  612,  613,  612, 1006, 1006,  614, 1006,
     1006, 1006,  611,  611,  611,  611, 1006, 1006, 1006,  715,
      694,  695,  695,  695,  695,  694,  695,  695,  695,  695,
      812,  812,  812,  812,  817,  817,  817,  817,  715,  716,
      717,  718,  718,  718,  718, 1006, 1006, 1006,  274,  468,
      816,  816,  816,  816,  605,  606,  605, 1006, 1006,  607,
      707,  708,  708,  708,  708, 1006, 1006,  274,  613,  613,
      613, 1006, 1006,  719, 1006,  720,  721,  722,  722,  722,
      722,  724,  613,  724, 1006, 1006,  725, 1006,  726,  727,
      728,  728,  728,  728,  606,  606,  606, 1006, 1006,  616,

     1006, 1006, 1006,  615,  615,  615,  615, 1006, 1006, 1006,
      729,  818,  818,  818,  818,  278,  822,  822,  822,  822,
      612,  613,  612, 1006, 1006,  614, 1006, 1006, 1006,  729,
      710,  606,  710, 1006, 1006,  711, 1006,  712,  713,  714,
      714,  714,  714,  618,  613,  618, 1006, 1006,  619, 1006,
      481,  482,  617,  617,  617,  617, 1006, 1006, 1006,  730,
      721,  722,  722,  722,  722,  823,  823,  823,  823,  824,
      824,  824,  824,  482,  830,  830,  830,  830,  730,  618,
      613,  618, 1006, 1006,  619, 1006,  731,  732,  733,  733,
      733,  733,  724,  613,  724, 1006, 1006,  725, 1006,  726,

      727,  728,  728,  728,  728,  286,  187,  286, 1006, 1006,
      287, 1006,  288,  289,  624,  624,  624,  624,  286,  187,
      286, 1006, 1006,  287, 1006,  288,  289,  624,  624,  624,
      624,  385,  385,  385, 1006, 1006,  386, 1006, 1006, 1006,
      626,  626,  626,  626,  491,  385,  491, 1006, 1006,  492,
     1006,  493,  494,  628,  628,  628,  628, 1006,  825,  825,
      735,  826,  826,  826,  826,  618,  613,  618,  831,  831,
      619,  832,  832,  832,  832,  859,  859,  859,  859,  735,
      296,  192,  296, 1006, 1006,  297, 1006,  298,  299,  631,
      631,  631,  631,  296,  192,  296, 1006, 1006,  297, 1006,

      298,  299,  631,  631,  631,  631,  388,  389,  388, 1006,
     1006,  390, 1006, 1006, 1006,  632,  632,  632,  632, 1006,
      839,  839,  736,  840,  840,  840,  840,  844,  844, 1006,
      845,  845,  845,  845,  852,  852, 1006,  853,  853,  853,
      853,  736,  385,  385,  385, 1006, 1006,  386, 1006, 1006,
     1006,  633,  633,  633,  633, 1006,  857,  857,  737,  858,
      858,  858,  858,  746,  747,  747,  747,  747,  746,  747,
      747,  747,  747,  860,  860,  860,  860,  737,  505,  389,
      505, 1006, 1006,  506, 1006,  507,  508,  634,  634,  634,
      634, 1006, 1006, 1006,  738,  542,  864,  864,  864,  864,

      651,  652,  651, 1006, 1006,  653,  759,  760,  760,  760,
      760, 1006, 1006,  738,  394,  394,  394, 1006, 1006,  395,
     1006, 1006, 1006,  636,  636,  636,  636,  515,  394,  515,
     1006, 1006,  516, 1006,  517,  518,  638,  638,  638,  638,
     1006, 1006, 1006,  740,  865,  865,  865,  865,  866,  866,
      866,  866,  321,  870,  870,  870,  870,  773,  774,  774,
      774,  774,  740,  306,  197,  306, 1006, 1006,  307, 1006,
      308,  309,  641,  641,  641,  641,  306,  197,  306, 1006,
     1006,  307, 1006,  308,  309,  641,  641,  641,  641,  397,
      398,  397, 1006, 1006,  399, 1006, 1006, 1006,  642,  642,

      642,  642,  658,  659,  658,  741, 1006,  660,  871,  871,
      871,  871,  872,  872,  872,  872,  873,  873, 1006,  874,
      874,  874,  874, 1006,  741,  394,  394,  394, 1006, 1006,
      395, 1006, 1006, 1006,  643,  643,  643,  643, 1006, 1006,
     1006,  742,  556,  878,  878,  878,  878,  664,  659,  664,
      879,  879,  665,  880,  880,  880,  880, 1006, 1006, 1006,
      742,  529,  398,  529, 1006, 1006,  530, 1006,  531,  532,
      644,  644,  644,  644, 1006,  887,  887,  743,  888,  888,
      888,  888, 1006,  135,  130,  135, 1006, 1006,  136,  797,
      797,  797,  797, 1006, 1006, 1006,  743,  405,  405,  405,

     1006, 1006,  406, 1006, 1006, 1006,  646,  646,  646,  646,
      648,  648,  648, 1006, 1006,  649,  892, 1006, 1006,  647,
      647,  647,  647,  135,  130,  135,  744, 1006,  136, 1006,
     1006,  893,  797,  797,  797,  797,  360,  361,  360, 1006,
     1006,  362, 1006, 1006, 1006,  744,  648,  648,  648, 1006,
     1006,  649, 1006,  745,  746,  747,  747,  747,  747,  749,
      648,  749, 1006, 1006,  750, 1006,  751,  752,  753,  753,
      753,  753,  651,  652,  651, 1006, 1006,  653, 1006,  541,
      542,  650,  650,  650,  650, 1006, 1006, 1006,  754,  805,
      805,  805,  805,  810,  810,  810,  810, 1006,  811,  811,

      811,  811, 1006, 1006, 1006,  896, 1006,  754,  651,  652,
      651, 1006, 1006,  653, 1006,  755,  756,  757,  757,  757,
      757,  652,  652,  652,  896, 1006,  662, 1006,  758,  759,
      760,  760,  760,  760,  762,  652,  762, 1006, 1006,  763,
     1006,  764,  765,  766,  766,  766,  766,  318,  208,  318,
     1006, 1006,  319, 1006,  320,  321,  656,  656,  656,  656,
      318,  208,  318, 1006, 1006,  319, 1006,  320,  321,  656,
      656,  656,  656,  658,  659,  658, 1006, 1006,  660, 1006,
     1006, 1006,  657,  657,  657,  657,  605,  606,  605,  767,
     1006,  607,  612,  613,  612, 1006, 1006,  614,  826,  826,

      826,  826,  618,  613,  618, 1006, 1006,  619,  767,  768,
      769,  770,  770,  770,  770, 1006, 1006, 1006,  317,  832,
      832,  832,  832,  832,  832,  832,  832,  388,  389,  388,
     1006, 1006,  390,  840,  840,  840,  840,  317,  659,  659,
      659, 1006, 1006,  771, 1006,  772,  773,  774,  774,  774,
      774,  776,  659,  776, 1006, 1006,  777, 1006,  778,  779,
      780,  780,  780,  780,  652,  652,  652, 1006, 1006,  662,
     1006, 1006, 1006,  661,  661,  661,  661, 1006, 1006, 1006,
      781,  845,  845,  845,  845,  845,  845,  845,  845,  397,
      398,  397, 1006, 1006,  399,  853,  853,  853,  853,  781,

      762,  652,  762, 1006, 1006,  763, 1006,  764,  765,  766,
      766,  766,  766,  664,  659,  664, 1006, 1006,  665, 1006,
      555,  556,  663,  663,  663,  663, 1006, 1006, 1006,  782,
      858,  858,  858,  858,  874,  874,  874,  874, 1006,  859,
      859,  859,  859, 1006, 1006, 1006,  905, 1006,  782,  664,
      659,  664, 1006, 1006,  665, 1006,  783,  784,  785,  785,
      785,  785,  776,  659,  776,  905, 1006,  777, 1006,  778,
      779,  780,  780,  780,  780,  328,  217,  328, 1006, 1006,
      329, 1006,  330,  331,  670,  670,  670,  670,  328,  217,
      328, 1006, 1006,  329, 1006,  330,  331,  670,  670,  670,

      670,  418,  418,  418, 1006, 1006,  419, 1006, 1006, 1006,
      672,  672,  672,  672,  565,  418,  565, 1006, 1006,  566,
     1006,  567,  568,  674,  674,  674,  674,  651,  652,  651,
      787, 1006,  653,  658,  659,  658, 1006, 1006,  660,  664,
      659,  664, 1006, 1006,  665,  880,  880,  880,  880,  787,
      338,  222,  338, 1006, 1006,  339, 1006,  340,  341,  677,
      677,  677,  677,  338,  222,  338, 1006, 1006,  339, 1006,
      340,  341,  677,  677,  677,  677,  421,  422,  421, 1006,
     1006,  423, 1006, 1006, 1006,  678,  678,  678,  678, 1006,
     1006, 1006,  788,  880,  880,  880,  880,  421,  422,  421,

     1006, 1006,  423,  888,  888,  888,  888,  919,  919,  919,
      919,  788,  418,  418,  418, 1006, 1006,  419, 1006, 1006,
     1006,  679,  679,  679,  679,  135,  130,  135,  789, 1006,
      136,  135,  130,  135, 1006, 1006,  136, 1006,  918,  918,
      915,  919,  919,  919,  919, 1006, 1006,  789,  579,  422,
      579, 1006, 1006,  580, 1006,  581,  582,  680,  680,  680,
      680,  914,  926,  926,  790,  927,  927,  927,  927,  934,
      934, 1006,  935,  935,  935,  935,  942,  942, 1006,  943,
      943,  943,  943,  790,  437,  357,  437, 1006, 1006,  438,
      798,  799,  440,  800,  800,  800,  800,  253,  161,  253,

     1006, 1006,  254,  801,  802,  256,  803,  803,  803,  803,
      451,  361,  451, 1006, 1006,  452,  806,  807,  454,  808,
      808,  808,  808,  697,  602,  697, 1006, 1006,  698, 1006,
      699,  700,  701,  701,  701,  701,  697,  602,  697, 1006,
     1006,  698, 1006,  699,  700,  701,  701,  701,  701,  465,
      370,  465, 1006, 1006,  466,  813,  814,  468,  815,  815,
      815,  815,  465,  370,  465, 1006, 1006,  466, 1006,  467,
      704,  705,  705,  705,  705,  602,  602,  602, 1006, 1006,
      603, 1006, 1006,  707,  708,  708,  708,  708,  710,  606,
      710, 1006, 1006,  711, 1006,  712,  713,  714,  714,  714,

      714,  710,  606,  710, 1006, 1006,  711, 1006,  712,  713,
      714,  714,  714,  714,  275,  175,  275, 1006, 1006,  276,
      819,  820,  278,  821,  821,  821,  821,  275,  175,  275,
     1006, 1006,  276, 1006,  277,  717,  718,  718,  718,  718,
      724,  613,  724, 1006, 1006,  725, 1006,  726,  727,  728,
      728,  728,  728,  606,  606,  606, 1006, 1006,  616, 1006,
     1006,  721,  722,  722,  722,  722,  724,  613,  724, 1006,
     1006,  725, 1006,  726,  727,  728,  728,  728,  728,  479,
      374,  479, 1006, 1006,  480,  827,  828,  482,  829,  829,
      829,  829,  479,  374,  479, 1006, 1006,  480, 1006,  481,

      732,  733,  733,  733,  733,  491,  385,  491, 1006, 1006,
      492,  833,  834,  494,  835,  835,  835,  835,  296,  192,
      296, 1006, 1006,  297,  836,  837,  299,  838,  838,  838,
      838,  505,  389,  505, 1006, 1006,  506,  841,  842,  508,
      843,  843,  843,  843,  515,  394,  515, 1006, 1006,  516,
      846,  847,  518,  848,  848,  848,  848,  306,  197,  306,
     1006, 1006,  307,  849,  850,  309,  851,  851,  851,  851,
      529,  398,  529, 1006, 1006,  530,  854,  855,  532,  856,
      856,  856,  856,  749,  648,  749, 1006, 1006,  750, 1006,
      751,  752,  753,  753,  753,  753,  749,  648,  749, 1006,

     1006,  750, 1006,  751,  752,  753,  753,  753,  753,  539,
      405,  539, 1006, 1006,  540,  861,  862,  542,  863,  863,
      863,  863,  539,  405,  539, 1006, 1006,  540, 1006,  541,
      756,  757,  757,  757,  757,  648,  648,  648, 1006, 1006,
      649, 1006, 1006,  759,  760,  760,  760,  760,  762,  652,
      762, 1006, 1006,  763, 1006,  764,  765,  766,  766,  766,
      766,  762,  652,  762, 1006, 1006,  763, 1006,  764,  765,
      766,  766,  766,  766,  318,  208,  318, 1006, 1006,  319,
      867,  868,  321,  869,  869,  869,  869,  318,  208,  318,
     1006, 1006,  319, 1006,  320,  769,  770,  770,  770,  770,

      776,  659,  776, 1006, 1006,  777, 1006,  778,  779,  780,
      780,  780,  780,  652,  652,  652, 1006, 1006,  662, 1006,
     1006,  773,  774,  774,  774,  774,  776,  659,  776, 1006,
     1006,  777, 1006,  778,  779,  780,  780,  780,  780,  553,
      409,  553, 1006, 1006,  554,  875,  876,  556,  877,  877,
      877,  877,  553,  409,  553, 1006, 1006,  554, 1006,  555,
      784,  785,  785,  785,  785,  565,  418,  565, 1006, 1006,
      566,  881,  882,  568,  883,  883,  883,  883,  338,  222,
      338, 1006, 1006,  339,  884,  885,  341,  886,  886,  886,
      886,  579,  422,  579, 1006, 1006,  580,  889,  890,  582,

      891,  891,  891,  891,  437,  357,  437, 1006, 1006,  438,
     1006,  439,  440,  800,  800,  800,  800,  437,  357,  437,
     1006, 1006,  438, 1006,  439,  440,  800,  800,  800,  800,
      253,  161,  253, 1006, 1006,  254, 1006,  255,  256,  803,
      803,  803,  803,  253,  161,  253, 1006, 1006,  254, 1006,
      255,  256,  803,  803,  803,  803,  357,  357,  357, 1006,
     1006,  358, 1006, 1006, 1006,  805,  805,  805,  805,  451,
      361,  451, 1006, 1006,  452, 1006,  453,  454,  808,  808,
      808,  808,  451,  361,  451, 1006, 1006,  452, 1006,  453,
      454,  808,  808,  808,  808,  602,  602,  602, 1006, 1006,

      603, 1006, 1006, 1006,  810,  810,  810,  810,  697,  602,
      697, 1006, 1006,  698, 1006,  699,  700,  812,  812,  812,
      812, 1006,  947,  948,  897,  949,  949,  949,  949,  950,
      950, 1006,  951,  951,  951,  951,  955,  956, 1006,  957,
      957,  957,  957,  897,  465,  370,  465, 1006, 1006,  466,
     1006,  467,  468,  815,  815,  815,  815,  465,  370,  465,
     1006, 1006,  466, 1006,  467,  468,  815,  815,  815,  815,
      605,  606,  605, 1006, 1006,  607, 1006, 1006, 1006,  816,
      816,  816,  816, 1006,  958,  958,  898,  959,  959,  959,
      959,  963,  964, 1006,  965,  965,  965,  965,  135,  130,

      967, 1006, 1006,  136, 1006,  898,  602,  602,  602, 1006,
     1006,  603, 1006, 1006, 1006,  817,  817,  817,  817,  135,
      130,  135,  899, 1006,  136,  919,  919,  919,  919,  605,
      606,  605, 1006, 1006,  607,  927,  927,  927,  927, 1006,
     1006,  899,  710,  606,  710, 1006, 1006,  711, 1006,  712,
      713,  818,  818,  818,  818,  612,  613,  612,  900, 1006,
      614, 1006, 1006,  966,  935,  935,  935,  935,  618,  613,
      618, 1006, 1006,  619, 1006, 1006, 1006,  900,  275,  175,
      275, 1006, 1006,  276, 1006,  277,  278,  821,  821,  821,
      821,  275,  175,  275, 1006, 1006,  276, 1006,  277,  278,

      821,  821,  821,  821,  612,  613,  612, 1006, 1006,  614,
     1006, 1006, 1006,  822,  822,  822,  822, 1006, 1006, 1006,
      901,  943,  943,  943,  943,  943,  943,  943,  943,  949,
      949,  949,  949,  949,  949,  949,  949, 1006, 1006,  901,
      606,  606,  606, 1006, 1006,  616, 1006, 1006, 1006,  823,
      823,  823,  823, 1006, 1006, 1006,  902,  951,  951,  951,
      951, 1006, 1006,  949,  949,  949,  949, 1006, 1006, 1006,
      538,  957,  957,  957,  957,  902,  724,  613,  724, 1006,
     1006,  725, 1006,  726,  727,  824,  824,  824,  824,  538,
     1006, 1006,  903,  957,  957,  957,  957,  959,  959,  959,

      959, 1006,  957,  957,  957,  957, 1006, 1006, 1006,  317,
     1006,  903,  606,  606,  606, 1006, 1006,  616, 1006, 1006,
     1006,  826,  826,  826,  826,  479,  374,  479,  317, 1006,
      480, 1006,  481,  482,  829,  829,  829,  829,  479,  374,
      479, 1006, 1006,  480, 1006,  481,  482,  829,  829,  829,
      829,  618,  613,  618, 1006, 1006,  619, 1006, 1006, 1006,
      830,  830,  830,  830, 1006, 1006, 1006,  904,  959,  959,
      959,  959,  965,  965,  965,  965,  965,  965,  965,  965,
      135,  130,  970, 1006, 1006,  136,  904,  491,  385,  491,
     1006, 1006,  492, 1006,  493,  494,  835,  835,  835,  835,

      491,  385,  491, 1006, 1006,  492, 1006,  493,  494,  835,
      835,  835,  835,  296,  192,  296, 1006, 1006,  297, 1006,
      298,  299,  838,  838,  838,  838,  296,  192,  296, 1006,
     1006,  297, 1006,  298,  299,  838,  838,  838,  838,  385,
      385,  385, 1006, 1006,  386, 1006, 1006, 1006,  840,  840,
      840,  840,  505,  389,  505, 1006, 1006,  506, 1006,  507,
      508,  843,  843,  843,  843,  505,  389,  505, 1006, 1006,
      506, 1006,  507,  508,  843,  843,  843,  843,  515,  394,
      515, 1006, 1006,  516, 1006,  517,  518,  848,  848,  848,
      848,  515,  394,  515, 1006, 1006,  516, 1006,  517,  518,

      848,  848,  848,  848,  306,  197,  306, 1006, 1006,  307,
     1006,  308,  309,  851,  851,  851,  851,  306,  197,  306,
     1006, 1006,  307, 1006,  308,  309,  851,  851,  851,  851,
      394,  394,  394, 1006, 1006,  395, 1006, 1006, 1006,  853,
      853,  853,  853,  529,  398,  529, 1006, 1006,  530, 1006,
      531,  532,  856,  856,  856,  856,  529,  398,  529, 1006,
     1006,  530, 1006,  531,  532,  856,  856,  856,  856,  648,
      648,  648, 1006, 1006,  649, 1006, 1006, 1006,  858,  858,
      858,  858,  749,  648,  749, 1006, 1006,  750, 1006,  751,
      752,  860,  860,  860,  860,  135,  130,  135,  906, 1006,

      973, 1006,  135,  130,  135, 1006, 1006,  136,  965,  965,
      965,  965, 1006, 1006, 1006,  552, 1006,  906,  539,  405,
      539, 1006, 1006,  540, 1006,  541,  542,  863,  863,  863,
      863,  539,  405,  539,  552, 1006,  540, 1006,  541,  542,
      863,  863,  863,  863,  651,  652,  651,  971, 1006,  653,
     1006, 1006, 1006,  864,  864,  864,  864,  135,  130,  135,
      907, 1006,  136,  135,  130,  135, 1006, 1006,  136, 1006,
      135,  130,  135, 1006,  975,  136, 1006, 1006, 1006,  907,
      648,  648,  648, 1006, 1006,  649, 1006, 1006, 1006,  865,
      865,  865,  865,  135,  130,  977,  908, 1006,  136, 1006,

     1006,  974,  135,  130,  135, 1006,  976,  136,  135,  130,
      135, 1006, 1006,  136,  978,  908,  762,  652,  762, 1006,
     1006,  763, 1006,  764,  765,  866,  866,  866,  866,  981,
      982,  981,  909, 1006,  983, 1006,  979,  135,  130,  135,
     1006, 1006,  136, 1006,  981,  982,  981, 1006,  984,  983,
     1006,  909,  318,  208,  318, 1006, 1006,  319, 1006,  320,
      321,  869,  869,  869,  869,  318,  208,  318, 1006, 1006,
      319, 1006,  320,  321,  869,  869,  869,  869,  658,  659,
      658, 1006, 1006,  660, 1006, 1006, 1006,  870,  870,  870,
      870,  981,  982,  981,  910, 1006,  983,  981,  982,  981,

     1006, 1006,  983,  135,  130,  135, 1006,  985,  136,  985,
     1006,  987,  986,  910,  652,  652,  652, 1006, 1006,  662,
     1006, 1006, 1006,  871,  871,  871,  871,  989, 1006,  989,
      911, 1006,  990,  135,  130,  135, 1006, 1006,  136,  989,
     1006,  989,  991,  989,  990,  989, 1006, 1006,  990,  911,
      776,  659,  776, 1006, 1006,  777, 1006,  778,  779,  872,
      872,  872,  872,  989, 1006,  989,  912, 1006,  990,  135,
      130,  992, 1006, 1001,  136, 1001, 1006, 1006, 1002,  135,
      130,  135, 1006, 1006,  136,  912,  652,  652,  652, 1006,
     1006,  662, 1006, 1006, 1006,  874,  874,  874,  874,  553,

      409,  553, 1006, 1006,  554, 1006,  555,  556,  877,  877,
      877,  877,  553,  409,  553,  995, 1006,  554, 1006,  555,
      556,  877,  877,  877,  877,  664,  659,  664, 1006, 1006,
      665, 1006, 1006, 1006,  878,  878,  878,  878,  998,  999,
      998,  913, 1006, 1000, 1006,  135,  130,  135, 1006, 1006,
      136, 1006,  135,  130,  135, 1006, 1006,  136, 1006, 1006,
      913,  565,  418,  565,  996, 1006,  566, 1006,  567,  568,
      883,  883,  883,  883,  565,  418,  565, 1006, 1006,  566,
     1006,  567,  568,  883,  883,  883,  883,  338,  222,  338,
      993, 1006,  339, 1006,  340,  341,  886,  886,  886,  886,

      338,  222,  338, 1006, 1006,  339, 1006,  340,  341,  886,
      886,  886,  886,  418,  418,  418, 1006, 1006,  419, 1006,
     1006, 1006,  888,  888,  888,  888,  579,  422,  579, 1006,
     1006,  580, 1006,  581,  582,  891,  891,  891,  891,  579,
      422,  579, 1006, 1006,  580, 1006,  581,  582,  891,  891,
      891,  891,  697,  602,  697, 1006, 1006,  698,  920,  921,
      700,  922,  922,  922,  922,  465,  370,  465, 1006, 1006,
      466,  923,  924,  468,  925,  925,  925,  925,  710,  606,
      710, 1006, 1006,  711,  928,  929,  713,  930,  930,  930,
      930,  275,  175,  275, 1006, 1006,  276,  931,  932,  278,

      933,  933,  933,  933,  724,  613,  724, 1006, 1006,  725,
      936,  937,  727,  938,  938,  938,  938,  479,  374,  479,
     1006, 1006,  480,  939,  940,  482,  941,  941,  941,  941,
      749,  648,  749, 1006, 1006,  750,  944,  945,  752,  946,
      946,  946,  946,  762,  652,  762, 1006, 1006,  763,  952,
      953,  765,  954,  954,  954,  954,  776,  659,  776, 1006,
     1006,  777,  960,  961,  779,  962,  962,  962,  962,  697,
      602,  697, 1006, 1006,  698, 1006,  699,  700,  922,  922,
      922,  922,  465,  370,  465, 1006, 1006,  466, 1006,  467,
      468,  925,  925,  925,  925,  602,  602,  602, 1006, 1006,

      603, 1006, 1006, 1006,  927,  927,  927,  927,  710,  606,
      710, 1006, 1006,  711, 1006,  712,  713,  930,  930,  930,
      930,  275,  175,  275, 1006, 1006,  276, 1006,  277,  278,
      933,  933,  933,  933,  606,  606,  606, 1006, 1006,  616,
     1006, 1006, 1006,  935,  935,  935,  935,  724,  613,  724,
     1006, 1006,  725, 1006,  726,  727,  938,  938,  938,  938,
      479,  374,  479, 1006, 1006,  480, 1006,  481,  482,  941,
      941,  941,  941,  648,  648,  648, 1006, 1006,  649, 1006,
     1006, 1006,  951,  951,  951,  951,  135,  130,  135, 1006,
     1006,  136,  998,  999,  998, 1006, 1006, 1000,  998,  999,

      998, 1006, 1006, 1000,  998,  999,  998, 1006, 1001, 1000,
     1001, 1006, 1004, 1002, 1004, 1006, 1004, 1005, 1004, 1006,
     1004, 1005, 1004, 1006, 1004, 1005, 1004, 1006, 1006, 1005,
      994,   46,   46,   46,   46,   46,   46,   46,   46,   50,
       50,   50,   50,   50,   50,   50,   50,   82,   82,   82,
       82,   82,   82,   82,   82,  110,  110,  110,  110,  110,
      110,  110,  110,  119,  119,  119,  119,  119,  119,  119,
      119,  128,  128, 1006,  128,  128,  128,  128,  128,  134,
      134,  134,  134,  134,  134,  134,  134,  140, 1006, 1006,
      140,  141,  141,  141,  141,  141,  141,  141,  141,  177,

     1006, 1006,  177, 1006,  177,  177,  177,  178,  178,  178,
      178,  178,  178,  178,  178,  210, 1006, 1006,  210, 1006,
      210,  210,  211,  211,  211,  211,  211,  211,  211,  211,
      224,  224, 1006,  224, 1006,  224,  224,  224,  227,  227,
      227,  227,  227,  227,  227,  227,  233,  233, 1006,  233,
      233,  233,  233,  233,  252,  252,  252,  252,  252,  252,
      252,  252,  262,  262,  262,  262,  262,  262,  262,  262,
      268,  268, 1006, 1006,  268,  268,  274,  274,  274,  274,
      274,  274,  274,  274,  285,  285,  285,  285,  285,  285,
      285,  285,  295,  295,  295,  295,  295,  295,  295,  295,

      305,  305,  305,  305,  305,  305,  305,  305,  317,  317,
      317,  317,  317,  317,  317,  317,  210, 1006, 1006,  210,
     1006,  210,  210,  211,  211,  211,  211,  211,  211,  211,
      211,  327,  327,  327,  327,  327,  327,  327,  327,  337,
      337,  337,  337,  337,  337,  337,  337,  224,  224, 1006,
      224, 1006,  224,  224,  224,  227,  227,  227,  227,  227,
      227,  227,  227,  233,  233, 1006,  233,  233,  233,  233,
      233,  134,  134,  134,  134,  134,  134,  134,  134,  140,
     1006, 1006,  140,  252,  252,  252,  252,  252,  252,  252,
      252,  262,  262,  262,  262,  262,  262,  262,  262,  268,

      268, 1006, 1006,  268,  268,  274,  274,  274,  274,  274,
      274,  274,  274,  436,  436,  436,  436,  436,  436,  436,
      436,  450,  450,  450,  450,  450,  450,  450,  450,  464,
      464,  464,  464,  464,  464,  464,  464,  478,  478,  478,
      478,  478,  478,  478,  478,  490,  490,  490,  490,  490,
      490,  490,  490,  295,  295,  295,  295,  295,  295,  295,
      295,  504,  504,  504,  504,  504,  504,  504,  504,  514,
      514,  514,  514,  514,  514,  514,  514,  305,  305,  305,
      305,  305,  305,  305,  305,  528,  528,  528,  528,  528,
      528,  528,  528,  538,  538,  538,  538,  538,  538,  538,

      538,  317,  317,  317,  317,  317,  317,  317,  317,  552,
      552,  552,  552,  552,  552,  552,  552,  327,  327,  327,
      327,  327,  327,  327,  327,  564,  564,  564,  564,  564,
      564,  564,  564,  337,  337,  337,  337,  337,  337,  337,
      337,  578,  578,  578,  578,  578,  578,  578,  578,  134,
      134,  134,  134,  134,  134,  134,  134,  140, 1006, 1006,
      140,  436,  436,  436,  436,  436,  436,  436,  436,  252,
      252,  252,  252,  252,  252,  252,  252,  450,  450,  450,
      450,  450,  450,  450,  450,  464,  464,  464,  464,  464,
      464,  464,  464,  274,  274,  274,  274,  274,  274,  274,

      274,  478,  478,  478,  478,  478,  478,  478,  478,  285,
      285,  285,  285,  285,  285,  285,  285,  490,  490,  490,
      490,  490,  490,  490,  490,  295,  295,  295,  295,  295,
      295,  295,  295,  504,  504,  504,  504,  504,  504,  504,
      504,  514,  514,  514,  514,  514,  514,  514,  514,  305,
      305,  305,  305,  305,  305,  305,  305,  528,  528,  528,
      528,  528,  528,  528,  528,  538,  538,  538,  538,  538,
      538,  538,  538,  317,  317,  317,  317,  317,  317,  317,
      317,  552,  552,  552,  552,  552,  552,  552,  552,  327,
      327,  327,  327,  327,  327,  327,  327,  564,  564,  564,

      564,  564,  564,  564,  564,  337,  337,  337,  337,  337,
      337,  337,  337,  578,  578,  578,  578,  578,  578,  578,
      578,  134,  134,  134,  134,  134,  134,  134,  134,  140,
     1006, 1006,  140,  436,  436,  436,  436,  436,  436,  436,
      436,  252,  252,  252,  252,  252,  252,  252,  252,  450,
      450,  450,  450,  450,  450,  450,  450,  696,  696,  696,
      696,  696,  696,  696,  696,  464,  464,  464,  464,  464,
      464,  464,  464,  709,  709,  709,  709,  709,  709,  709,
      709,  274,  274,  274,  274,  274,  274,  274,  274,  723,
      723,  723,  723,  723,  723,  723,  723,  478,  478,  478,

      478,  478,  478,  478,  478,  285,  285,  285,  285,  285,
      285,  285,  285,  490,  490,  490,  490,  490,  490,  490,
      490,  295,  295,  295,  295,  295,  295,  295,  295,  504,
      504,  504,  504,  504,  504,  504,  504,  514,  514,  514,
      514,  514,  514,  514,  514,  305,  305,  305,  305,  305,
      305,  305,  305,  528,  528,  528,  528,  528,  528,  528,
      528,  748,  748,  748,  748,  748,  748,  748,  748,  538,
      538,  538,  538,  538,  538,  538,  538,  761,  761,  761,
      761,  761,  761,  761,  761,  317,  317,  317,  317,  317,
      317,  317,  317,  775,  775,  775,  775,  775,  775,  775,

      775,  552,  552,  552,  552,  552,  552,  552,  552,  327,
      327,  327,  327,  327,  327,  327,  327,  564,  564,  564,
      564,  564,  564,  564,  564,  337,  337,  337,  337,  337,
      337,  337,  337,  578,  578,  578,  578,  578,  578,  578,
      578,  134,  134,  134,  134,  134,  134,  134,  134,  140,
     1006, 1006,  140,  436,  436,  436,  436,  436,  436,  436,
      436,  252,  252,  252,  252,  252,  252,  252,  252,  450,
      450,  450,  450,  450,  450,  450,  450,  696,  696,  696,
      696,  696,  696,  696,  696,  464,  464,  464,  464,  464,
      464,  464,  464,  709,  709,  709,  709,  709,  709,  709,

      709,  274,  274,  274,  274,  274,  274,  274,  274,  723,
      723,  723,  723,  723,  723,  723,  723,  478,  478,  478,
      478,  478,  478,  478,  478,  490,  490,  490,  490,  490,
      490,  490,  490,  295,  295,  295,  295,  295,  295,  295,
      295,  504,  504,  504,  504,  504,  504,  504,  504,  514,
      514,  514,  514,  514,  514,  514,  514,  305,  305,  305,
      305,  305,  305,  305,  305,  528,  528,  528,  528,  528,
      528,  528,  528,  748,  748,  748,  748,  748,  748,  748,
      748,  538,  538,  538,  538,  538,  538,  538,  538,  761,
      761,  761,  761,  761,  761,  761,  761,  317,  317,  317,

      317,  317,  317,  317,  317,  775,  775,  775,  775,  775,
      775,  775,  775,  552,  552,  552,  552,  552,  552,  552,
      552,  564,  564,  564,  564,  564,  564,  564,  564,  337,
      337,  337,  337,  337,  337,  337,  337,  578,  578,  578,
      578,  578,  578,  578,  578,  134,  134,  134,  134,  134,
      134,  134,  134,  140, 1006, 1006,  140,  436,  436,  436,
      436,  436,  436,  436,  436,  252,  252,  252,  252,  252,
      252,  252,  252,  450,  450,  450,  450,  450,  450,  450,
      450,  696,  696,  696,  696,  696,  696,  696,  696,  464,
      464,  464,  464,  464,  464,  464,  464,  709,  709,  709,

      709,  709,  709,  709,  709,  274,  274,  274,  274,  274,
      274,  274,  274,  723,  723,  723,  723,  723,  723,  723,
      723,  478,  478,  478,  478,  478,  478,  478,  478,  490,
      490,  490,  490,  490,  490,  490,  490,  295,  295,  295,
      295,  295,  295,  295,  295,  504,  504,  504,  504,  504,
      504,  504,  504,  514,  514,  514,  514,  514,  514,  514,
      514,  305,  305,  305,  305,  305,  305,  305,  305,  528,
      528,  528,  528,  528,  528,  528,  528,  748,  748,  748,
      748,  748,  748,  748,  748,  538,  538,  538,  538,  538,
      538,  538,  538,  761,  761,  761,  761,  761,  761,  761,

      761,  317,  317,  317,  317,  317,  317,  317,  317,  775,
      775,  775,  775,  775,  775,  775,  775,  552,  552,  552,
      552,  552,  552,  552,  552,  564,  564,  564,  564,  564,
      564,  564,  564,  337,  337,  337,  337,  337,  337,  337,
      337,  578,  578,  578,  578,  578,  578,  578,  578,  134,
      134,  134,  134,  134,  134,  134,  134,  140, 1006, 1006,
      140,  696,  696,  696,  696,  696,  696,  696,  696,  464,
      464,  464,  464,  464,  464,  464,  464,  709,  709,  709,
      709,  709,  709,  709,  709,  274,  274,  274,  274,  274,
      274,  274,  274,  723,  723,  723,  723,  723,  723,  723,

      723,  478,  478,  478,  478,  478,  478,  478,  478,  980,
      980,  980,  980,  980,  980,  980,  980,  988,  988, 1006,
      988,  988,  988,  988,  988,  997,  997,  997,  997,  997,
      997,  997,  997, 1003, 1003, 1006, 1003, 1003, 1003, 1003,
     1003,   45, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006

    } ;

static const short int yy_chk[8592] =
    {   0,
        0,    1,    1,    1,    0,    0,    1,    2,    2,    2,
      944,  944,    2,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    5,    5,    5,   62,   62,    5,    6,    6,
        6,  428, 1071,    6, 1050,  428,   47,   47,   47,    5,
        5,   47,   48,   75,   48,    6,    6,   48,    5,   67,
       67,   67,   67,   67,    6,    7,    7,    7,  945,  945,

        7,   75,    7,    7,    7,    7,    7,    7,   68,   68,
       68,   68, 1046,    7,    9,    9,    9,    9,    9,    9,
       10,   10,   10,   10,   10,   10,   11,   11,   11,   11,
       11,   11,   12,   12,   12,   12,   12,   12,   13,   13,
       13,   13,   13,   13,   14,   14,   14,   14,   14,   14,
       15,   15,   15,   15,   15,   15,   16,   16,   16,   16,
       16,   16,   17,   17,   17, 1039,   17,   17,   18,   18,
       18, 1031,   18,   18,   19,   19,   19,   19,   19,   19,
       17,   70,   70,   70,   70,   70,   18,   20,   20,   20,
       20,   20,   20,   21,   21,   21,   21,   21,   21,   22,

       22,   22,   22,   22,   22,   23,   23,   23,   23,   23,
       23,   24,   24,   24,   24,   24,   24,   25,   25,   25,
       25,   25,   25,  267, 1026,   39,   39,   39,   25,   39,
       39,   40,   40,   40,  969,   40,   40,  946,  946,  458,
       25,  267,   25,   26,   26,   26,   26,   26,   26,  459,
       51,   51,   51,  917,   26,   51,   39,  458,  916,   41,
       41,   41,   40,   41,   41,  895,   26,  459,   26,   27,
       27,   27,   27,   27,   27,  952,  952,   42,   42,   42,
       27,   42,   42,   49,   49,   49,  953,  953,   49,  894,
       41,  795,   27,  793,   27,   28,   28,   28,   28,   28,

       28,  686,   53,   53,   53,  685,   28,   53,   42,  954,
      954,   49,   71,   71,   71,   71,  960,  960,   28,  683,
       28,   29,   29,   29,   29,   29,   29,   72,   72,   72,
       72,   72,   29,  588,   43,   43,   43,   43,   43,   43,
       73,   73,   73,   73,   29,   43,   29,   30,   30,   30,
       30,   30,   30,   76,   76,   76,   76,  587,   30,  586,
       44,   44,   44,   44,   44,   44,   78,   78,   78,   78,
       30,   44,   30,   31,   31,   31,   31,   31,   31,   79,
       79,   79,   79,   79,   31,   77,   77,   77,   77,   80,
       80,   80,   80,  961,  961,  585,   31,  429,   31,   32,

       32,   32,   32,   32,   32,   77,  425,   84,   84,   84,
       32,   84,   84,   86,   86,   86,   86,   86,   87,   87,
       87,   87,   32,   77,   32,   33,   33,   33,  352,   33,
       33,   88,   88,   88,   88,   88,   89,   89,   89,   89,
       89,  962,  962,   33,   90,   90,   90,   90,   92,   92,
       92,   92,   92,  351,  350,   33,  349,   33,   34,   34,
       34,  348,   34,   34,   93,   93,   93,   93,   95,   95,
       95,   95,   95,  347,  345,  247,   34,   96,   96,   96,
       96,  101,  101,  101,  101,  101,  246,  245,   34,  244,
       34,   35,   35,   35,   35,   35,   35,  102,  102,  102,

      102,  243,   35,  103,  103,  103,  103,  103,  104,  104,
      104,  104,  241,  240,   35,  239,   35,   36,   36,   36,
       36,   36,   36,  106,  106,  106,  106,  238,   36,  105,
      105,  105,  105,  107,  107,  107,  107,  107,  157,  155,
       36,  154,   36,   37,   37,   37,   37,   37,   37,  105,
      108,  108,  108,  108,   37,  111,  111,  111,  153,  111,
      111,  113,  113,  113,  113,  113,   37,  105,   37,   38,
       38,   38,   38,   38,   38,  114,  114,  114,  114,  152,
       38,  117,  117,  117,  117,  111,  151,  111,  120,  120,
      120,  149,   38,  120,   38,   69,   69,   69,  148,  147,

       69,  145,  144,   69,   69,   69,   69,   69,   74,   74,
       74,  123,  112,   74,   98,   85,   66,   74,   74,   74,
       74,  116,  116,  116,  116,  116,  122,  122,  122,   65,
      122,  122,  125,  125,  125,  125,   64,   74,  127,  127,
      127,  127,  129,  129,  129,   63,  130,  129,  130,   61,
       60,  130,   59,   58,   57,   74,   81,   81,   81,   56,
       55,   81,   54,   45,   81,   81,   81,   81,   81,   91,
       91,   91,    0,    0,   91,    0,    0,   91,   91,   91,
       91,   91,   94,   94,   94,    0,    0,   94,    0,    0,
       94,   94,   94,   94,   94,   97,   97,   97,    0,    0,

       97,    0,    0,   97,   97,   97,   97,   97,  109,  109,
      109,    0,    0,  109,    0,    0,  109,  109,  109,  109,
      109,  115,  115,  115,    0,    0,  115,    0,    0,  115,
      115,  115,  115,  115,  118,  118,  118,    0,    0,  118,
        0,    0,  118,  118,  118,  118,  118,  126,  126,  126,
      126,  131,  131,  131,    0,  132,  131,  132,    0,  133,
      132,  133,    0,    0,  133,    0,    0,  126,  134,  134,
      134,    0,    0,  134,  135,  135,  135,    0,    0,  135,
        0,  136,  136,  136,    0,  126,  136,  137,  137,  137,
        0,    0,  137,  138,  138,  138,    0,    0,  138,  139,

      139,  139,    0,    0,  139,  141,  141,  141,    0,    0,
      141,  137,  142,  142,  142,    0,    0,  142,  143,  143,
      143,    0,    0,  143,  158,  158,  158,  158,  160,  160,
      160,    0,    0,  160,    0,    0,    0,  160,  160,  160,
      160,    0,    0,    0,  160,  163,  163,  163,  163,  164,
      164,  164,  164,  164,  165,  165,  165,  165,    0,    0,
        0,  165,    0,  160,  161,  161,  161,    0,    0,  161,
        0,  161,  161,  161,  161,  161,  161,  162,  162,  162,
      165,    0,  162,    0,  162,  162,  162,  162,  162,  162,
      167,  167,  167,    0,    0,  167,    0,  167,    0,  167,

      167,  167,  167,  168,  168,  168,    0,    0,  168,    0,
      168,    0,  168,  168,  168,  168,  169,  169,  169,    0,
        0,  169,  170,  170,  170,  170,  172,  172,  172,  172,
      174,  174,  174,    0,    0,  174,    0,    0,    0,  174,
      174,  174,  174,  178,  178,  178,  174,  178,  178,  179,
      179,  179,    0,  179,  179,  181,  181,  181,  181,  182,
      182,  182,  182,  182,    0,  174,  175,  175,  175,    0,
        0,  175,    0,  175,  175,  175,  175,  175,  175,  176,
      176,  176,    0,    0,  176,    0,  176,  176,  176,  176,
      176,  176,  183,  183,  183,  183,    0,    0,    0,  183,

      184,  184,  184,  184,  189,  189,  189,  189,  194,  194,
      194,  194,  200,  200,  200,  200,    0,    0,  183,  186,
      186,  186,    0,    0,  186,    0,    0,    0,  186,  186,
      186,  186,    0,    0,    0,  186,  201,  201,  201,  201,
      201,  203,  203,  203,  203,  202,  202,  202,  202,    0,
        0,    0,  202,    0,  186,  187,  187,  187,    0,    0,
      187,    0,  187,  187,  187,  187,  187,  187,  188,  188,
      188,  202,    0,  188,    0,  188,  188,  188,  188,  188,
      188,  191,  191,  191,    0,    0,  191,    0,    0,    0,
      191,  191,  191,  191,    0,    0,    0,  191,  205,  205,

      205,  205,    0,    0,  211,  211,  211,    0,  211,  211,
      214,  214,  214,  214,    0,    0,  191,  192,  192,  192,
        0,    0,  192,    0,  192,  192,  192,  192,  192,  192,
      193,  193,  193,    0,  211,  193,  211,  193,  193,  193,
      193,  193,  193,  196,  196,  196,    0,    0,  196,    0,
        0,    0,  196,  196,  196,  196,    0,    0,    0,  196,
      219,  219,  219,  219,    0,    0,  212,  212,  212,    0,
      212,  212,  225,  225,  225,    0,    0,  225,  196,  197,
      197,  197,    0,    0,  197,    0,  197,  197,  197,  197,
      197,  197,  198,  198,  198,    0,  212,  198,  212,  198,

      198,  198,  198,  198,  198,  207,  207,  207,    0,    0,
      207,    0,    0,    0,  207,  207,  207,  207,  226,  226,
      226,  207,  226,  226,  227,  227,  227,    0,  227,  227,
      228,  228,  228,    0,  228,  228,  231,  231,  231,  231,
      207,  208,  208,  208,    0,    0,  208,    0,  208,  208,
      208,  208,  208,  208,  209,  209,  209,    0,    0,  209,
        0,  209,  209,  209,  209,  209,  209,  215,  215,  215,
        0,    0,  215,    0,    0,  215,  215,  215,  215,  215,
      216,  216,  216,    0,    0,  216,    0,    0,    0,  216,
      216,  216,  216,  229,  229,  229,  216,  229,  229,  233,

      234,  233,  234,    0,  233,  234,  235,  982,  235,  982,
        0,  235,  982,    0,    0,  216,  217,  217,  217,    0,
        0,  217,    0,  217,  217,  217,  217,  217,  217,  218,
      218,  218,    0,    0,  218,    0,  218,  218,  218,  218,
      218,  218,  220,  220,  220,    0,    0,  220,    0,    0,
      220,  220,  220,  220,  220,  221,  221,  221,    0,    0,
      221,    0,    0,    0,  221,  221,  221,  221,  236,  236,
      236,  221,    0,  236,  248,  248,    0,  248,  248,  248,
      248,  249,  249,  249,  249,  249,    0,    0,  236,    0,
      221,  222,  222,  222,    0,    0,  222,    0,  222,  222,

      222,  222,  222,  222,  223,  223,  223,    0,    0,  223,
        0,  223,  223,  223,  223,  223,  223,  250,  250,  250,
      250,  251,  251,  251,    0,    0,  251,    0,    0,  251,
      251,  251,  251,  251,  252,  252,  252,    0,    0,  252,
        0,  252,  252,  252,  252,  252,  252,  253,  253,  253,
        0,    0,  253,    0,  253,  253,  253,  253,  253,  253,
      256,  256,  256,  256,  257,  257,  257,  258,  258,  257,
      258,  258,  258,  258,  259,  259,  259,  259,  260,  260,
      260,  260,  261,  261,  261,  261,  268,  268,  268,  270,
      270,  268,  270,  270,  270,  270,    0,    0,  260,  271,

      271,  271,  271,  271,  272,  272,  272,  272,  278,  278,
      278,  278,  283,  283,  283,  283,  260,  262,  262,  262,
        0,    0,  262,    0,  262,    0,  262,  262,  262,  262,
      263,  263,  263,    0,    0,  263,    0,  263,    0,  263,
      263,  263,  263,  264,  264,  264,    0,    0,  264,    0,
      264,    0,  264,  264,  264,  264,  265,  265,  265,    0,
        0,  265,    0,  265,    0,  265,  265,  265,  265,  266,
      266,  266,    0,    0,  266,    0,  266,    0,  266,  266,
      266,  266,  279,  279,  279,  280,  280,  279,  280,  280,
      280,  280,  289,  289,  289,  289,  281,  281,  266,  281,

      281,  281,  281,  282,  282,  282,  282,  282,  284,  284,
      284,  284,  284,    0,    0,    0,  266,  273,  273,  273,
        0,    0,  273,    0,    0,  273,  273,  273,  273,  273,
      274,  274,  274,    0,    0,  274,    0,  274,  274,  274,
      274,  274,  274,  275,  275,  275,    0,    0,  275,    0,
      275,  275,  275,  275,  275,  275,  285,  285,  285,    0,
        0,  285,    0,  285,  285,  285,  285,  285,  285,  291,
      291,    0,  291,  291,  291,  291,  292,  292,  292,  292,
      292,  293,  293,  293,  293,  294,  294,  294,    0,    0,
      294,    0,    0,  294,  294,  294,  294,  294,  295,  295,

      295,    0,    0,  295,    0,  295,  295,  295,  295,  295,
      295,  299,  299,  299,  299,  300,  300,  300,  301,  301,
      300,  301,  301,  301,  301,  302,  302,  302,  302,  302,
      303,  303,  303,  303,  304,  304,  304,    0,    0,  304,
        0,    0,  304,  304,  304,  304,  304,  305,  305,  305,
        0,    0,  305,    0,  305,  305,  305,  305,  305,  305,
      309,  309,  309,  309,  310,  310,  310,  311,  311,  310,
      311,  311,  311,  311,  313,  313,    0,  313,  313,  313,
      313,  314,  314,  314,  314,  314,  315,  315,  315,  315,
      316,  316,  316,    0,    0,  316,    0,    0,  316,  316,

      316,  316,  316,  317,  317,  317,    0,    0,  317,    0,
      317,  317,  317,  317,  317,  317,  321,  321,  321,  321,
      322,  322,  322,  323,  323,  322,  323,  323,  323,  323,
      324,  324,  324,  324,  324,  325,  325,  325,  325,  326,
      326,  326,  326,  326,  327,  327,  327,    0,    0,  327,
        0,  327,  327,  327,  327,  327,  327,  331,  331,  331,
      331,  333,  333,    0,  333,  333,  333,  333,  334,  334,
      334,  334,  334,  335,  335,  335,  335,  336,  336,  336,
        0,    0,  336,    0,    0,  336,  336,  336,  336,  336,
      337,  337,  337,    0,    0,  337,    0,  337,  337,  337,

      337,  337,  337,  341,  341,  341,  341,  342,  342,  342,
        0,    0,  342,  344,  344,  344,    0,    0,  344,  354,
      354,  354,  354,  363,  363,  363,  363,  364,  364,  364,
      364,    0,  344,  355,  355,  355,    0,    0,  355,    0,
        0,    0,  355,  355,  355,  355,  356,  356,  356,    0,
        0,  356,    0,    0,    0,  356,  356,  356,  356,    0,
        0,    0,  356,  367,  367,  367,  367,  376,  376,  376,
      376,  377,  377,  377,  377,  378,  378,  378,  378,    0,
        0,  356,  357,  357,  357,    0,    0,  357,    0,  357,
      357,  357,  357,  357,  357,  358,  358,  358,    0,    0,

      358,    0,  358,  358,  358,  358,  358,  358,  359,  359,
      359,    0,    0,  359,    0,    0,    0,  359,  359,  359,
      359,    0,    0,    0,  359,  380,  380,  380,  380,    0,
        0,    0,  380,  381,  381,  381,  381,  424,  424,  424,
      381,    0,  424,  359,  360,  360,  360,  360,  360,  360,
        0,  380,    0,  360,  382,  382,  382,  382,    0,  381,
      391,  391,  391,  391,  400,  400,  400,  400,  401,  401,
      401,  401,  360,  361,  361,  361,    0,    0,  361,    0,
      361,  361,  361,  361,  361,  361,  362,  362,  362,    0,
        0,  362,    0,  362,  362,  362,  362,  362,  362,  366,

      366,  366,  366,  366,  366,  366,  366,  366,  402,  402,
      402,  402,  411,  411,  411,  411,  445,  445,  445,  366,
        0,  445,    0,  366,  366,  366,  366,    0,  413,  413,
      413,  413,    0,    0,    0,  413,    0,  366,  368,  368,
      368,    0,    0,  368,    0,    0,    0,  368,  368,  368,
      368,  369,  369,  369,  413,    0,  369,    0,    0,    0,
      369,  369,  369,  369,    0,    0,    0,  369,  415,  415,
      415,  415,  432,  432,    0,  432,  432,  432,  432,  433,
      433,  433,  433,  433,    0,    0,  369,  370,  370,  370,
        0,    0,  370,    0,  370,  370,  370,  370,  370,  370,

      371,  371,  371,    0,    0,  371,    0,  371,  371,  371,
      371,  371,  371,  372,  372,  372,    0,    0,  372,    0,
        0,    0,  372,  372,  372,  372,    0,    0,    0,  372,
      434,  434,  434,  434,  435,  435,  435,  435,  435,  440,
      440,  440,  440,  444,  444,  444,  444,  444,  372,  373,
      373,  373,  373,  373,  373,    0,    0,    0,  373,  447,
      447,  447,  447,  447,  448,  448,  448,  448,  454,  454,
      454,  454,  461,  461,  461,  461,  461,  373,  374,  374,
      374,    0,    0,  374,    0,  374,  374,  374,  374,  374,
      374,  375,  375,  375,    0,    0,  375,    0,  375,  375,

      375,  375,  375,  375,  379,  379,  379,    0,    0,  379,
        0,    0,    0,  379,  379,  379,  379,  383,  383,  383,
        0,    0,  383,    0,    0,    0,  383,  383,  383,  383,
      384,  384,  384,    0,    0,  384,    0,    0,    0,  384,
      384,  384,  384,    0,  460,  460,  384,  460,  460,  460,
      460,  462,  462,  462,  462,  468,  468,  468,  468,  469,
      469,  469,    0,    0,  469,  384,  385,  385,  385,    0,
        0,  385,    0,  385,  385,  385,  385,  385,  385,  386,
      386,  386,    0,    0,  386,    0,  386,  386,  386,  386,
      386,  386,  387,  387,  387,    0,    0,  387,    0,  387,

      387,  387,  387,  387,  387,    0,    0,    0,  387,  472,
      472,  472,  472,  472,  473,  473,  473,    0,    0,  473,
      475,  475,  475,  475,  475,    0,    0,  387,  388,  388,
      388,    0,    0,  388,    0,  388,  388,  388,  388,  388,
      388,  389,  389,  389,    0,    0,  389,    0,  389,  389,
      389,  389,  389,  389,  390,  390,  390,    0,    0,  390,
        0,  390,  390,  390,  390,  390,  390,  392,  392,  392,
        0,    0,  392,    0,    0,    0,  392,  392,  392,  392,
      393,  393,  393,    0,    0,  393,    0,    0,    0,  393,
      393,  393,  393,    0,    0,    0,  393,  476,  476,  476,

      476,  482,  482,  482,  482,  483,  483,  483,  484,  484,
      483,  484,  484,  484,  484,  393,  394,  394,  394,    0,
        0,  394,    0,  394,  394,  394,  394,  394,  394,  395,
      395,  395,    0,    0,  395,    0,  395,  395,  395,  395,
      395,  395,  396,  396,  396,    0,    0,  396,    0,  396,
      396,  396,  396,  396,  396,    0,  486,  486,  396,  486,
      486,  486,  486,  487,  487,  487,  487,  487,  488,  488,
      488,  488,  489,  489,  489,  489,  489,  396,  397,  397,
      397,    0,    0,  397,    0,  397,  397,  397,  397,  397,
      397,  398,  398,  398,    0,    0,  398,    0,  398,  398,

      398,  398,  398,  398,  399,  399,  399,    0,    0,  399,
        0,  399,  399,  399,  399,  399,  399,  403,  403,  403,
        0,    0,  403,    0,    0,    0,  403,  403,  403,  403,
      404,  404,  404,    0,    0,  404,    0,    0,    0,  404,
      404,  404,  404,    0,    0,    0,  404,  494,  494,  494,
      494,  498,  498,  498,  498,  498,  499,  499,  499,    0,
        0,  499,    0,    0,    0,  404,  405,  405,  405,    0,
        0,  405,    0,  405,  405,  405,  405,  405,  405,  406,
      406,  406,    0,    0,  406,    0,  406,  406,  406,  406,
      406,  406,  407,  407,  407,    0,    0,  407,    0,  407,

      407,  407,  407,  407,  407,    0,    0,    0,  407,  501,
      501,  501,  501,  501,  502,  502,  502,  502,  508,  508,
      508,  508,  511,  511,  511,  511,  511,  407,  408,  408,
      408,    0,    0,  408,    0,  408,  408,  408,  408,  408,
      408,  409,  409,  409,    0,    0,  409,    0,  409,  409,
      409,  409,  409,  409,  410,  410,  410,    0,    0,  410,
        0,  410,  410,  410,  410,  410,  410,  412,  412,  412,
        0,    0,  412,    0,    0,    0,  412,  412,  412,  412,
      414,  414,  414,    0,    0,  414,    0,  414,  414,  414,
      414,  414,  414,    0,  510,  510,  414,  510,  510,  510,

      510,  512,  512,  512,  512,  513,  513,  513,  513,  513,
      518,  518,  518,  518,    0,  414,  416,  416,  416,    0,
        0,  416,    0,    0,    0,  416,  416,  416,  416,  417,
      417,  417,    0,    0,  417,    0,    0,    0,  417,  417,
      417,  417,    0,    0,    0,  417,  522,  522,  522,  522,
      522,  523,  523,  523,    0,    0,  523,  525,  525,  525,
      525,  525,    0,    0,  417,  418,  418,  418,    0,    0,
      418,    0,  418,  418,  418,  418,  418,  418,  419,  419,
      419,    0,    0,  419,    0,  419,  419,  419,  419,  419,
      419,  420,  420,  420,    0,    0,  420,    0,  420,  420,

      420,  420,  420,  420,    0,    0,    0,  420,  526,  526,
      526,  526,  532,  532,  532,  532,  534,  534,    0,  534,
      534,  534,  534,    0,    0,    0,  420,  421,  421,  421,
        0,    0,  421,    0,  421,  421,  421,  421,  421,  421,
      422,  422,  422,    0,    0,  422,    0,  422,  422,  422,
      422,  422,  422,  423,  423,  423,    0,    0,  423,    0,
      423,  423,  423,  423,  423,  423,  436,  436,  436,    0,
        0,  436,    0,  436,  436,  436,  436,  436,  436,  437,
      437,  437,    0,    0,  437,    0,  437,  437,  437,  437,
      437,  437,  442,  442,  442,    0,    0,  442,  442,  442,

      442,  442,  442,  442,  442,  443,  443,  443,    0,    0,
      443,    0,  443,  443,  443,  443,  443,  443,  446,  446,
      446,    0,    0,  446,    0,  446,  446,  446,  446,  446,
      446,  449,  449,  449,    0,    0,  449,    0,    0,  449,
      449,  449,  449,  449,  450,  450,  450,    0,    0,  450,
        0,  450,  450,  450,  450,  450,  450,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,

      457,  457,  457,  457,  457,  457,  463,  463,  463,    0,
        0,  463,    0,    0,  463,  463,  463,  463,  463,  464,
      464,  464,    0,    0,  464,    0,  464,  464,  464,  464,
      464,  464,  465,  465,  465,    0,    0,  465,    0,  465,
      465,  465,  465,  465,  465,  470,  470,  470,    0,    0,
      470,  470,  470,  470,  470,  470,  470,  470,  471,  471,
      471,    0,    0,  471,    0,  471,  471,  471,  471,  471,
      471,  474,  474,  474,    0,    0,  474,    0,  474,  474,
      474,  474,  474,  474,  477,  477,  477,    0,    0,  477,
        0,    0,  477,  477,  477,  477,  477,  478,  478,  478,

        0,    0,  478,    0,  478,  478,  478,  478,  478,  478,
      485,  485,  485,    0,    0,  485,  485,  485,  485,  485,
      485,  485,  485,  490,  490,  490,    0,    0,  490,    0,
      490,  490,  490,  490,  490,  490,  491,  491,  491,    0,
        0,  491,    0,  491,  491,  491,  491,  491,  491,  496,
      496,  496,    0,    0,  496,  496,  496,  496,  496,  496,
      496,  496,  497,  497,  497,    0,    0,  497,    0,  497,
      497,  497,  497,  497,  497,  500,  500,  500,    0,    0,
      500,    0,  500,  500,  500,  500,  500,  500,  503,  503,
      503,    0,    0,  503,    0,    0,  503,  503,  503,  503,

      503,  504,  504,  504,    0,    0,  504,    0,  504,  504,
      504,  504,  504,  504,  514,  514,  514,    0,    0,  514,
        0,  514,  514,  514,  514,  514,  514,  515,  515,  515,
        0,    0,  515,    0,  515,  515,  515,  515,  515,  515,
      520,  520,  520,    0,    0,  520,  520,  520,  520,  520,
      520,  520,  520,  521,  521,  521,    0,    0,  521,    0,
      521,  521,  521,  521,  521,  521,  524,  524,  524,    0,
        0,  524,    0,  524,  524,  524,  524,  524,  524,  527,
      527,  527,    0,    0,  527,    0,    0,  527,  527,  527,
      527,  527,  528,  528,  528,    0,    0,  528,    0,  528,

      528,  528,  528,  528,  528,  535,  535,  535,  535,  535,
      536,  536,  536,  536,  537,  537,  537,    0,    0,  537,
        0,    0,  537,  537,  537,  537,  537,  538,  538,  538,
        0,    0,  538,    0,  538,  538,  538,  538,  538,  538,
      539,  539,  539,    0,    0,  539,    0,  539,  539,  539,
      539,  539,  539,  542,  542,  542,  542,  543,  543,  543,
        0,    0,  543,  544,  544,  544,    0,    0,  544,  544,
      544,  544,  544,  544,  544,  544,  545,  545,  545,    0,
        0,  545,    0,  545,  545,  545,  545,  545,  545,  546,
      546,  546,  546,  546,  547,  547,  547,    0,    0,  547,

      548,  548,  548,    0,    0,  548,    0,  548,  548,  548,
      548,  548,  548,  549,  549,  549,  549,  549,  550,  550,
      550,  550,  551,  551,  551,    0,    0,  551,    0,    0,
      551,  551,  551,  551,  551,  552,  552,  552,    0,    0,
      552,    0,  552,  552,  552,  552,  552,  552,  556,  556,
      556,  556,  557,  557,  557,  558,  558,  557,  558,  558,
      558,  558,  559,  559,  559,    0,    0,  559,  559,  559,
      559,  559,  559,  559,  559,  560,  560,    0,  560,  560,
      560,  560,  561,  561,  561,  561,  561,  562,  562,  562,
      562,  563,  563,  563,  563,  563,  564,  564,  564,    0,

        0,  564,    0,  564,  564,  564,  564,  564,  564,  565,
      565,  565,    0,    0,  565,    0,  565,  565,  565,  565,
      565,  565,  568,  568,  568,  568,  570,  570,  570,    0,
        0,  570,  570,  570,  570,  570,  570,  570,  570,  571,
      571,  571,    0,    0,  571,    0,  571,  571,  571,  571,
      571,  571,  572,  572,  572,  572,  572,  573,  573,  573,
        0,    0,  573,  574,  574,  574,    0,    0,  574,    0,
      574,  574,  574,  574,  574,  574,  575,  575,  575,  575,
      575,  576,  576,  576,  576,  577,  577,  577,    0,    0,
      577,    0,    0,  577,  577,  577,  577,  577,  578,  578,

      578,    0,    0,  578,    0,  578,  578,  578,  578,  578,
      578,  582,  582,  582,  582,  584,  584,  584,    0,    0,
      584,  589,  589,  589,  589,  591,  591,  591,  591,    0,
      584,    0,  591,  595,  595,  595,    0,    0,  595,  599,
      599,  599,  599,  584,  590,  590,  590,    0,    0,  590,
        0,  591,    0,  590,  590,  590,  590,  592,  592,  592,
        0,    0,  592,    0,  592,  592,  592,  592,  592,  592,
      610,  610,  610,  592,    0,  610,  620,  620,  620,  620,
      621,  621,  621,  621,  625,  625,  625,  625,  635,  635,
      635,  635,  592,  593,  593,  593,    0,    0,  593,    0,

      593,  593,  593,  593,  593,  593,  594,  594,  594,    0,
        0,  594,    0,  594,  594,  594,  594,  594,  594,  596,
      596,  596,    0,    0,  596,    0,    0,    0,  596,  596,
      596,  596,    0,    0,    0,  596,  627,  627,  627,  627,
      631,  631,  631,  627,    0,  631,  637,  637,  637,  637,
        0,    0,    0,  637,  596,  597,  597,  597,    0,    0,
      597,    0,  627,    0,  597,  597,  597,  597,  641,  641,
      641,  597,  637,  641,  645,  645,  645,  645,  656,  656,
      656,    0,    0,  656,  666,  666,  666,  666,    0,    0,
      597,  598,  598,  598,    0,    0,  598,    0,  598,  598,

      598,  598,  598,  598,    0,    0,    0,  598,  667,  667,
      667,  667,  671,  671,  671,  671,    0,  673,  673,  673,
      673,    0,    0,    0,  673,    0,  598,  600,  600,  600,
        0,    0,  600,    0,    0,    0,  600,  600,  600,  600,
      601,  601,  601,  673,    0,  601,    0,    0,    0,  601,
      601,  601,  601,  677,  677,  677,  601,    0,  677,  694,
      694,  694,  694,  681,  681,  681,    0,    0,  681,  682,
      682,  682,    0,    0,  682,  601,  602,  602,  602,    0,
      682,  602,    0,  602,  602,  602,  602,  602,  602,  603,
      603,  603,    0,    0,  603,    0,  603,  603,  603,  603,

      603,  603,  604,  604,  604,  681,    0,  604,    0,  604,
      604,  604,  604,  604,  604,    0,  687,  687,  604,  687,
      687,  687,  687,  690,  690,    0,  690,  690,  690,  690,
      692,  692,    0,  692,  692,  692,  692,  604,  605,  605,
      605,    0,    0,  605,    0,  605,  605,  605,  605,  605,
      605,  606,  606,  606,    0,    0,  606,    0,  606,  606,
      606,  606,  606,  606,  607,  607,  607,    0,    0,  607,
        0,  607,  607,  607,  607,  607,  607,  608,  608,  608,
        0,    0,  608,    0,  608,  608,  608,  608,  608,  608,
      609,  609,  609,    0,    0,  609,    0,  609,  609,  609,

      609,  609,  609,  611,  611,  611,    0,    0,  611,    0,
        0,    0,  611,  611,  611,  611,    0,    0,    0,  611,
      693,  693,  693,  693,  693,  695,  695,  695,  695,  695,
      700,  700,  700,  700,  707,  707,  707,  707,  611,  612,
      612,  612,  612,  612,  612,    0,    0,    0,  612,  704,
      704,  704,  704,  704,  705,  705,  705,    0,    0,  705,
      706,  706,  706,  706,  706,    0,    0,  612,  613,  613,
      613,    0,    0,  613,    0,  613,  613,  613,  613,  613,
      613,  614,  614,  614,    0,    0,  614,    0,  614,  614,
      614,  614,  614,  614,  615,  615,  615,    0,    0,  615,

        0,    0,    0,  615,  615,  615,  615,    0,    0,    0,
      615,  713,  713,  713,  713,  717,  717,  717,  717,  717,
      718,  718,  718,    0,    0,  718,    0,    0,    0,  615,
      616,  616,  616,    0,    0,  616,    0,  616,  616,  616,
      616,  616,  616,  617,  617,  617,    0,    0,  617,    0,
      617,  617,  617,  617,  617,  617,    0,    0,    0,  617,
      720,  720,  720,  720,  720,  721,  721,  721,  721,  727,
      727,  727,  727,  732,  732,  732,  732,  732,  617,  618,
      618,  618,    0,    0,  618,    0,  618,  618,  618,  618,
      618,  618,  619,  619,  619,    0,    0,  619,    0,  619,

      619,  619,  619,  619,  619,  622,  622,  622,    0,    0,
      622,    0,  622,  622,  622,  622,  622,  622,  623,  623,
      623,    0,    0,  623,    0,  623,  623,  623,  623,  623,
      623,  626,  626,  626,    0,    0,  626,    0,    0,    0,
      626,  626,  626,  626,  628,  628,  628,    0,    0,  628,
        0,  628,  628,  628,  628,  628,  628,    0,  729,  729,
      628,  729,  729,  729,  729,  733,  733,  733,  734,  734,
      733,  734,  734,  734,  734,  746,  746,  746,  746,  628,
      629,  629,  629,    0,    0,  629,    0,  629,  629,  629,
      629,  629,  629,  630,  630,  630,    0,    0,  630,    0,

      630,  630,  630,  630,  630,  630,  632,  632,  632,    0,
        0,  632,    0,    0,    0,  632,  632,  632,  632,    0,
      737,  737,  632,  737,  737,  737,  737,  739,  739,    0,
      739,  739,  739,  739,  742,  742,    0,  742,  742,  742,
      742,  632,  633,  633,  633,    0,    0,  633,    0,    0,
        0,  633,  633,  633,  633,    0,  744,  744,  633,  744,
      744,  744,  744,  745,  745,  745,  745,  745,  747,  747,
      747,  747,  747,  752,  752,  752,  752,  633,  634,  634,
      634,    0,    0,  634,    0,  634,  634,  634,  634,  634,
      634,    0,    0,    0,  634,  756,  756,  756,  756,  756,

      757,  757,  757,    0,    0,  757,  758,  758,  758,  758,
      758,    0,    0,  634,  636,  636,  636,    0,    0,  636,
        0,    0,    0,  636,  636,  636,  636,  638,  638,  638,
        0,    0,  638,    0,  638,  638,  638,  638,  638,  638,
        0,    0,    0,  638,  759,  759,  759,  759,  765,  765,
      765,  765,  769,  769,  769,  769,  769,  772,  772,  772,
      772,  772,  638,  639,  639,  639,    0,    0,  639,    0,
      639,  639,  639,  639,  639,  639,  640,  640,  640,    0,
        0,  640,    0,  640,  640,  640,  640,  640,  640,  642,
      642,  642,    0,    0,  642,    0,    0,    0,  642,  642,

      642,  642,  770,  770,  770,  642,    0,  770,  773,  773,
      773,  773,  779,  779,  779,  779,  781,  781,    0,  781,
      781,  781,  781,    0,  642,  643,  643,  643,    0,    0,
      643,    0,    0,    0,  643,  643,  643,  643,    0,    0,
        0,  643,  784,  784,  784,  784,  784,  785,  785,  785,
      786,  786,  785,  786,  786,  786,  786,    0,    0,    0,
      643,  644,  644,  644,    0,    0,  644,    0,  644,  644,
      644,  644,  644,  644,    0,  789,  789,  644,  789,  789,
      789,  789,    0,  791,  791,  791,    0,    0,  791,  796,
      796,  796,  796,    0,    0,    0,  644,  646,  646,  646,

        0,    0,  646,    0,    0,    0,  646,  646,  646,  646,
      647,  647,  647,    0,    0,  647,  791,    0,    0,  647,
      647,  647,  647,  792,  792,  792,  647,    0,  792,    0,
        0,  792,  797,  797,  797,  797,  803,  803,  803,    0,
        0,  803,    0,    0,    0,  647,  648,  648,  648,    0,
        0,  648,    0,  648,  648,  648,  648,  648,  648,  649,
      649,  649,    0,    0,  649,    0,  649,  649,  649,  649,
      649,  649,  650,  650,  650,    0,    0,  650,    0,  650,
      650,  650,  650,  650,  650,    0,    0,    0,  650,  804,
      804,  804,  804,  809,  809,  809,  809,    0,  811,  811,

      811,  811,    0,    0,    0,  811,    0,  650,  651,  651,
      651,    0,    0,  651,    0,  651,  651,  651,  651,  651,
      651,  652,  652,  652,  811,    0,  652,    0,  652,  652,
      652,  652,  652,  652,  653,  653,  653,    0,    0,  653,
        0,  653,  653,  653,  653,  653,  653,  654,  654,  654,
        0,    0,  654,    0,  654,  654,  654,  654,  654,  654,
      655,  655,  655,    0,    0,  655,    0,  655,  655,  655,
      655,  655,  655,  657,  657,  657,    0,    0,  657,    0,
        0,    0,  657,  657,  657,  657,  815,  815,  815,  657,
        0,  815,  821,  821,  821,    0,    0,  821,  825,  825,

      825,  825,  829,  829,  829,    0,    0,  829,  657,  658,
      658,  658,  658,  658,  658,    0,    0,    0,  658,  831,
      831,  831,  831,  832,  832,  832,  832,  838,  838,  838,
        0,    0,  838,  839,  839,  839,  839,  658,  659,  659,
      659,    0,    0,  659,    0,  659,  659,  659,  659,  659,
      659,  660,  660,  660,    0,    0,  660,    0,  660,  660,
      660,  660,  660,  660,  661,  661,  661,    0,    0,  661,
        0,    0,    0,  661,  661,  661,  661,    0,    0,    0,
      661,  844,  844,  844,  844,  845,  845,  845,  845,  851,
      851,  851,    0,    0,  851,  852,  852,  852,  852,  661,

      662,  662,  662,    0,    0,  662,    0,  662,  662,  662,
      662,  662,  662,  663,  663,  663,    0,    0,  663,    0,
      663,  663,  663,  663,  663,  663,    0,    0,    0,  663,
      857,  857,  857,  857,  873,  873,  873,  873,    0,  859,
      859,  859,  859,    0,    0,    0,  859,    0,  663,  664,
      664,  664,    0,    0,  664,    0,  664,  664,  664,  664,
      664,  664,  665,  665,  665,  859,    0,  665,    0,  665,
      665,  665,  665,  665,  665,  668,  668,  668,    0,    0,
      668,    0,  668,  668,  668,  668,  668,  668,  669,  669,
      669,    0,    0,  669,    0,  669,  669,  669,  669,  669,

      669,  672,  672,  672,    0,    0,  672,    0,    0,    0,
      672,  672,  672,  672,  674,  674,  674,    0,    0,  674,
        0,  674,  674,  674,  674,  674,  674,  863,  863,  863,
      674,    0,  863,  869,  869,  869,    0,    0,  869,  877,
      877,  877,    0,    0,  877,  879,  879,  879,  879,  674,
      675,  675,  675,    0,    0,  675,    0,  675,  675,  675,
      675,  675,  675,  676,  676,  676,    0,    0,  676,    0,
      676,  676,  676,  676,  676,  676,  678,  678,  678,    0,
        0,  678,    0,    0,    0,  678,  678,  678,  678,    0,
        0,    0,  678,  880,  880,  880,  880,  886,  886,  886,

        0,    0,  886,  887,  887,  887,  887,  918,  918,  918,
      918,  678,  679,  679,  679,    0,    0,  679,    0,    0,
        0,  679,  679,  679,  679,  892,  892,  892,  679,    0,
      892,  893,  893,  893,    0,    0,  893,    0,  896,  896,
      893,  896,  896,  896,  896,    0,    0,  679,  680,  680,
      680,    0,    0,  680,    0,  680,  680,  680,  680,  680,
      680,  892,  899,  899,  680,  899,  899,  899,  899,  902,
      902,    0,  902,  902,  902,  902,  905,  905,    0,  905,
      905,  905,  905,  680,  688,  688,  688,    0,    0,  688,
      688,  688,  688,  688,  688,  688,  688,  689,  689,  689,

        0,    0,  689,  689,  689,  689,  689,  689,  689,  689,
      691,  691,  691,    0,    0,  691,  691,  691,  691,  691,
      691,  691,  691,  696,  696,  696,    0,    0,  696,    0,
      696,  696,  696,  696,  696,  696,  697,  697,  697,    0,
        0,  697,    0,  697,  697,  697,  697,  697,  697,  702,
      702,  702,    0,    0,  702,  702,  702,  702,  702,  702,
      702,  702,  703,  703,  703,    0,    0,  703,    0,  703,
      703,  703,  703,  703,  703,  708,  708,  708,    0,    0,
      708,    0,    0,  708,  708,  708,  708,  708,  709,  709,
      709,    0,    0,  709,    0,  709,  709,  709,  709,  709,

      709,  710,  710,  710,    0,    0,  710,    0,  710,  710,
      710,  710,  710,  710,  715,  715,  715,    0,    0,  715,
      715,  715,  715,  715,  715,  715,  715,  716,  716,  716,
        0,    0,  716,    0,  716,  716,  716,  716,  716,  716,
      719,  719,  719,    0,    0,  719,    0,  719,  719,  719,
      719,  719,  719,  722,  722,  722,    0,    0,  722,    0,
        0,  722,  722,  722,  722,  722,  723,  723,  723,    0,
        0,  723,    0,  723,  723,  723,  723,  723,  723,  730,
      730,  730,    0,    0,  730,  730,  730,  730,  730,  730,
      730,  730,  731,  731,  731,    0,    0,  731,    0,  731,

      731,  731,  731,  731,  731,  735,  735,  735,    0,    0,
      735,  735,  735,  735,  735,  735,  735,  735,  736,  736,
      736,    0,    0,  736,  736,  736,  736,  736,  736,  736,
      736,  738,  738,  738,    0,    0,  738,  738,  738,  738,
      738,  738,  738,  738,  740,  740,  740,    0,    0,  740,
      740,  740,  740,  740,  740,  740,  740,  741,  741,  741,
        0,    0,  741,  741,  741,  741,  741,  741,  741,  741,
      743,  743,  743,    0,    0,  743,  743,  743,  743,  743,
      743,  743,  743,  748,  748,  748,    0,    0,  748,    0,
      748,  748,  748,  748,  748,  748,  749,  749,  749,    0,

        0,  749,    0,  749,  749,  749,  749,  749,  749,  754,
      754,  754,    0,    0,  754,  754,  754,  754,  754,  754,
      754,  754,  755,  755,  755,    0,    0,  755,    0,  755,
      755,  755,  755,  755,  755,  760,  760,  760,    0,    0,
      760,    0,    0,  760,  760,  760,  760,  760,  761,  761,
      761,    0,    0,  761,    0,  761,  761,  761,  761,  761,
      761,  762,  762,  762,    0,    0,  762,    0,  762,  762,
      762,  762,  762,  762,  767,  767,  767,    0,    0,  767,
      767,  767,  767,  767,  767,  767,  767,  768,  768,  768,
        0,    0,  768,    0,  768,  768,  768,  768,  768,  768,

      771,  771,  771,    0,    0,  771,    0,  771,  771,  771,
      771,  771,  771,  774,  774,  774,    0,    0,  774,    0,
        0,  774,  774,  774,  774,  774,  775,  775,  775,    0,
        0,  775,    0,  775,  775,  775,  775,  775,  775,  782,
      782,  782,    0,    0,  782,  782,  782,  782,  782,  782,
      782,  782,  783,  783,  783,    0,    0,  783,    0,  783,
      783,  783,  783,  783,  783,  787,  787,  787,    0,    0,
      787,  787,  787,  787,  787,  787,  787,  787,  788,  788,
      788,    0,    0,  788,  788,  788,  788,  788,  788,  788,
      788,  790,  790,  790,    0,    0,  790,  790,  790,  790,

      790,  790,  790,  790,  798,  798,  798,    0,    0,  798,
        0,  798,  798,  798,  798,  798,  798,  799,  799,  799,
        0,    0,  799,    0,  799,  799,  799,  799,  799,  799,
      801,  801,  801,    0,    0,  801,    0,  801,  801,  801,
      801,  801,  801,  802,  802,  802,    0,    0,  802,    0,
      802,  802,  802,  802,  802,  802,  805,  805,  805,    0,
        0,  805,    0,    0,    0,  805,  805,  805,  805,  806,
      806,  806,    0,    0,  806,    0,  806,  806,  806,  806,
      806,  806,  807,  807,  807,    0,    0,  807,    0,  807,
      807,  807,  807,  807,  807,  810,  810,  810,    0,    0,

      810,    0,    0,    0,  810,  810,  810,  810,  812,  812,
      812,    0,    0,  812,    0,  812,  812,  812,  812,  812,
      812,    0,  907,  907,  812,  907,  907,  907,  907,  908,
      908,    0,  908,  908,  908,  908,  910,  910,    0,  910,
      910,  910,  910,  812,  813,  813,  813,    0,    0,  813,
        0,  813,  813,  813,  813,  813,  813,  814,  814,  814,
        0,    0,  814,    0,  814,  814,  814,  814,  814,  814,
      816,  816,  816,    0,    0,  816,    0,    0,    0,  816,
      816,  816,  816,    0,  911,  911,  816,  911,  911,  911,
      911,  913,  913,    0,  913,  913,  913,  913,  915,  915,

      915,    0,    0,  915,    0,  816,  817,  817,  817,    0,
        0,  817,    0,    0,    0,  817,  817,  817,  817,  914,
      914,  914,  817,    0,  914,  919,  919,  919,  919,  925,
      925,  925,    0,    0,  925,  926,  926,  926,  926,    0,
        0,  817,  818,  818,  818,    0,    0,  818,    0,  818,
      818,  818,  818,  818,  818,  933,  933,  933,  818,    0,
      933,    0,    0,  914,  934,  934,  934,  934,  941,  941,
      941,    0,    0,  941,    0,    0,    0,  818,  819,  819,
      819,    0,    0,  819,    0,  819,  819,  819,  819,  819,
      819,  820,  820,  820,    0,    0,  820,    0,  820,  820,

      820,  820,  820,  820,  822,  822,  822,    0,    0,  822,
        0,    0,    0,  822,  822,  822,  822,    0,    0,    0,
      822,  942,  942,  942,  942,  943,  943,  943,  943,  947,
      947,  947,  947,  948,  948,  948,  948,    0,    0,  822,
      823,  823,  823,    0,    0,  823,    0,    0,    0,  823,
      823,  823,  823,    0,    0,    0,  823,  950,  950,  950,
      950,    0,    0,  949,  949,  949,  949,    0,    0,    0,
      949,  955,  955,  955,  955,  823,  824,  824,  824,    0,
        0,  824,    0,  824,  824,  824,  824,  824,  824,  949,
        0,    0,  824,  956,  956,  956,  956,  958,  958,  958,

      958,    0,  957,  957,  957,  957,    0,    0,    0,  957,
        0,  824,  826,  826,  826,    0,    0,  826,    0,    0,
        0,  826,  826,  826,  826,  827,  827,  827,  957,    0,
      827,    0,  827,  827,  827,  827,  827,  827,  828,  828,
      828,    0,    0,  828,    0,  828,  828,  828,  828,  828,
      828,  830,  830,  830,    0,    0,  830,    0,    0,    0,
      830,  830,  830,  830,    0,    0,    0,  830,  959,  959,
      959,  959,  963,  963,  963,  963,  964,  964,  964,  964,
      966,  966,  966,    0,    0,  966,  830,  833,  833,  833,
        0,    0,  833,    0,  833,  833,  833,  833,  833,  833,

      834,  834,  834,    0,    0,  834,    0,  834,  834,  834,
      834,  834,  834,  836,  836,  836,    0,    0,  836,    0,
      836,  836,  836,  836,  836,  836,  837,  837,  837,    0,
        0,  837,    0,  837,  837,  837,  837,  837,  837,  840,
      840,  840,    0,    0,  840,    0,    0,    0,  840,  840,
      840,  840,  841,  841,  841,    0,    0,  841,    0,  841,
      841,  841,  841,  841,  841,  842,  842,  842,    0,    0,
      842,    0,  842,  842,  842,  842,  842,  842,  846,  846,
      846,    0,    0,  846,    0,  846,  846,  846,  846,  846,
      846,  847,  847,  847,    0,    0,  847,    0,  847,  847,

      847,  847,  847,  847,  849,  849,  849,    0,    0,  849,
        0,  849,  849,  849,  849,  849,  849,  850,  850,  850,
        0,    0,  850,    0,  850,  850,  850,  850,  850,  850,
      853,  853,  853,    0,    0,  853,    0,    0,    0,  853,
      853,  853,  853,  854,  854,  854,    0,    0,  854,    0,
      854,  854,  854,  854,  854,  854,  855,  855,  855,    0,
        0,  855,    0,  855,  855,  855,  855,  855,  855,  858,
      858,  858,    0,    0,  858,    0,    0,    0,  858,  858,
      858,  858,  860,  860,  860,    0,    0,  860,    0,  860,
      860,  860,  860,  860,  860,  970,  970,  970,  860,    0,

      970,    0,  967,  967,  967,    0,    0,  967,  965,  965,
      965,  965,    0,    0,    0,  965,    0,  860,  861,  861,
      861,    0,    0,  861,    0,  861,  861,  861,  861,  861,
      861,  862,  862,  862,  965,    0,  862,    0,  862,  862,
      862,  862,  862,  862,  864,  864,  864,  967,    0,  864,
        0,    0,    0,  864,  864,  864,  864,  971,  971,  971,
      864,    0,  971,  973,  973,  973,    0,    0,  973,    0,
      974,  974,  974,    0,  973,  974,    0,    0,    0,  864,
      865,  865,  865,    0,    0,  865,    0,    0,    0,  865,
      865,  865,  865,  975,  975,  975,  865,    0,  975,    0,

        0,  971,  976,  976,  976,    0,  974,  976,  977,  977,
      977,    0,    0,  977,  976,  865,  866,  866,  866,    0,
        0,  866,    0,  866,  866,  866,  866,  866,  866,  978,
      978,  978,  866,    0,  978,    0,  977,  979,  979,  979,
        0,    0,  979,    0,  980,  980,  980,    0,  979,  980,
        0,  866,  867,  867,  867,    0,    0,  867,    0,  867,
      867,  867,  867,  867,  867,  868,  868,  868,    0,    0,
      868,    0,  868,  868,  868,  868,  868,  868,  870,  870,
      870,    0,    0,  870,    0,    0,    0,  870,  870,  870,
      870,  981,  981,  981,  870,    0,  981,  983,  983,  983,

        0,    0,  983,  984,  984,  984,    0,  985,  984,  985,
        0,  984,  985,  870,  871,  871,  871,    0,    0,  871,
        0,    0,    0,  871,  871,  871,  871,  986,    0,  986,
      871,    0,  986,  987,  987,  987,    0,    0,  987,  988,
        0,  988,  987,  989,  988,  989,    0,    0,  989,  871,
      872,  872,  872,    0,    0,  872,    0,  872,  872,  872,
      872,  872,  872,  990,    0,  990,  872,    0,  990,  991,
      991,  991,    0,  999,  991,  999,    0,    0,  999,  994,
      994,  994,    0,    0,  994,  872,  874,  874,  874,    0,
        0,  874,    0,    0,    0,  874,  874,  874,  874,  875,

      875,  875,    0,    0,  875,    0,  875,  875,  875,  875,
      875,  875,  876,  876,  876,  994,    0,  876,    0,  876,
      876,  876,  876,  876,  876,  878,  878,  878,    0,    0,
      878,    0,    0,    0,  878,  878,  878,  878,  996,  996,
      996,  878,    0,  996,    0,  992,  992,  992,    0,    0,
      992,    0,  995,  995,  995,    0,    0,  995,    0,    0,
      878,  881,  881,  881,  995,    0,  881,    0,  881,  881,
      881,  881,  881,  881,  882,  882,  882,    0,    0,  882,
        0,  882,  882,  882,  882,  882,  882,  884,  884,  884,
      992,    0,  884,    0,  884,  884,  884,  884,  884,  884,

      885,  885,  885,    0,    0,  885,    0,  885,  885,  885,
      885,  885,  885,  888,  888,  888,    0,    0,  888,    0,
        0,    0,  888,  888,  888,  888,  889,  889,  889,    0,
        0,  889,    0,  889,  889,  889,  889,  889,  889,  890,
      890,  890,    0,    0,  890,    0,  890,  890,  890,  890,
      890,  890,  897,  897,  897,    0,    0,  897,  897,  897,
      897,  897,  897,  897,  897,  898,  898,  898,    0,    0,
      898,  898,  898,  898,  898,  898,  898,  898,  900,  900,
      900,    0,    0,  900,  900,  900,  900,  900,  900,  900,
      900,  901,  901,  901,    0,    0,  901,  901,  901,  901,

      901,  901,  901,  901,  903,  903,  903,    0,    0,  903,
      903,  903,  903,  903,  903,  903,  903,  904,  904,  904,
        0,    0,  904,  904,  904,  904,  904,  904,  904,  904,
      906,  906,  906,    0,    0,  906,  906,  906,  906,  906,
      906,  906,  906,  909,  909,  909,    0,    0,  909,  909,
      909,  909,  909,  909,  909,  909,  912,  912,  912,    0,
        0,  912,  912,  912,  912,  912,  912,  912,  912,  920,
      920,  920,    0,    0,  920,    0,  920,  920,  920,  920,
      920,  920,  923,  923,  923,    0,    0,  923,    0,  923,
      923,  923,  923,  923,  923,  927,  927,  927,    0,    0,

      927,    0,    0,    0,  927,  927,  927,  927,  928,  928,
      928,    0,    0,  928,    0,  928,  928,  928,  928,  928,
      928,  931,  931,  931,    0,    0,  931,    0,  931,  931,
      931,  931,  931,  931,  935,  935,  935,    0,    0,  935,
        0,    0,    0,  935,  935,  935,  935,  936,  936,  936,
        0,    0,  936,    0,  936,  936,  936,  936,  936,  936,
      939,  939,  939,    0,    0,  939,    0,  939,  939,  939,
      939,  939,  939,  951,  951,  951,    0,    0,  951,    0,
        0,    0,  951,  951,  951,  951,  993,  993,  993,    0,
        0,  993,  997,  997,  997,    0,    0,  997,  998,  998,

      998,    0,    0,  998, 1000, 1000, 1000,    0, 1001, 1000,
     1001,    0, 1002, 1001, 1002,    0, 1003, 1002, 1003,    0,
     1004, 1003, 1004,    0, 1005, 1004, 1005,    0,    0, 1005,
      993, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1009, 1009, 1009,
     1009, 1009, 1009, 1009, 1009, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
     1011, 1012, 1012,    0, 1012, 1012, 1012, 1012, 1012, 1013,
     1013, 1013, 1013, 1013, 1013, 1013, 1013, 1014,    0,    0,
     1014, 1015, 1015, 1015, 1015, 1015, 1015, 1015, 1015, 1016,

        0,    0, 1016,    0, 1016, 1016, 1016, 1017, 1017, 1017,
     1017, 1017, 1017, 1017, 1017, 1018,    0,    0, 1018,    0,
     1018, 1018, 1019, 1019, 1019, 1019, 1019, 1019, 1019, 1019,
     1020, 1020,    0, 1020,    0, 1020, 1020, 1020, 1021, 1021,
     1021, 1021, 1021, 1021, 1021, 1021, 1022, 1022,    0, 1022,
     1022, 1022, 1022, 1022, 1023, 1023, 1023, 1023, 1023, 1023,
     1023, 1023, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
     1025, 1025,    0,    0, 1025, 1025, 1027, 1027, 1027, 1027,
     1027, 1027, 1027, 1027, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1029, 1029, 1029, 1029, 1029, 1029, 1029, 1029,

     1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1033,    0,    0, 1033,
        0, 1033, 1033, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1035, 1035, 1035, 1035, 1035, 1035, 1035, 1035, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1037, 1037,    0,
     1037,    0, 1037, 1037, 1037, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1040, 1040,    0, 1040, 1040, 1040, 1040,
     1040, 1041, 1041, 1041, 1041, 1041, 1041, 1041, 1041, 1042,
        0,    0, 1042, 1043, 1043, 1043, 1043, 1043, 1043, 1043,
     1043, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1045,

     1045,    0,    0, 1045, 1045, 1047, 1047, 1047, 1047, 1047,
     1047, 1047, 1047, 1048, 1048, 1048, 1048, 1048, 1048, 1048,
     1048, 1049, 1049, 1049, 1049, 1049, 1049, 1049, 1049, 1051,
     1051, 1051, 1051, 1051, 1051, 1051, 1051, 1052, 1052, 1052,
     1052, 1052, 1052, 1052, 1052, 1053, 1053, 1053, 1053, 1053,
     1053, 1053, 1053, 1054, 1054, 1054, 1054, 1054, 1054, 1054,
     1054, 1055, 1055, 1055, 1055, 1055, 1055, 1055, 1055, 1056,
     1056, 1056, 1056, 1056, 1056, 1056, 1056, 1057, 1057, 1057,
     1057, 1057, 1057, 1057, 1057, 1058, 1058, 1058, 1058, 1058,
     1058, 1058, 1058, 1059, 1059, 1059, 1059, 1059, 1059, 1059,

     1059, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1060, 1061,
     1061, 1061, 1061, 1061, 1061, 1061, 1061, 1062, 1062, 1062,
     1062, 1062, 1062, 1062, 1062, 1063, 1063, 1063, 1063, 1063,
     1063, 1063, 1063, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1065, 1065, 1065, 1065, 1065, 1065, 1065, 1065, 1066,
     1066, 1066, 1066, 1066, 1066, 1066, 1066, 1067,    0,    0,
     1067, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 1069,
     1069, 1069, 1069, 1069, 1069, 1069, 1069, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1072, 1072, 1072, 1072, 1072,
     1072, 1072, 1072, 1073, 1073, 1073, 1073, 1073, 1073, 1073,

     1073, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1075,
     1075, 1075, 1075, 1075, 1075, 1075, 1075, 1076, 1076, 1076,
     1076, 1076, 1076, 1076, 1076, 1077, 1077, 1077, 1077, 1077,
     1077, 1077, 1077, 1078, 1078, 1078, 1078, 1078, 1078, 1078,
     1078, 1079, 1079, 1079, 1079, 1079, 1079, 1079, 1079, 1080,
     1080, 1080, 1080, 1080, 1080, 1080, 1080, 1081, 1081, 1081,
     1081, 1081, 1081, 1081, 1081, 1082, 1082, 1082, 1082, 1082,
     1082, 1082, 1082, 1083, 1083, 1083, 1083, 1083, 1083, 1083,
     1083, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1085,
     1085, 1085, 1085, 1085, 1085, 1085, 1085, 1086, 1086, 1086,

     1086, 1086, 1086, 1086, 1086, 1087, 1087, 1087, 1087, 1087,
     1087, 1087, 1087, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
     1088, 1089, 1089, 1089, 1089, 1089, 1089, 1089, 1089, 1090,
        0,    0, 1090, 1091, 1091, 1091, 1091, 1091, 1091, 1091,
     1091, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1092, 1093,
     1093, 1093, 1093, 1093, 1093, 1093, 1093, 1094, 1094, 1094,
     1094, 1094, 1094, 1094, 1094, 1095, 1095, 1095, 1095, 1095,
     1095, 1095, 1095, 1096, 1096, 1096, 1096, 1096, 1096, 1096,
     1096, 1097, 1097, 1097, 1097, 1097, 1097, 1097, 1097, 1098,
     1098, 1098, 1098, 1098, 1098, 1098, 1098, 1099, 1099, 1099,

     1099, 1099, 1099, 1099, 1099, 1100, 1100, 1100, 1100, 1100,
     1100, 1100, 1100, 1101, 1101, 1101, 1101, 1101, 1101, 1101,
     1101, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1103,
     1103, 1103, 1103, 1103, 1103, 1103, 1103, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1105, 1105, 1105, 1105, 1105,
     1105, 1105, 1105, 1106, 1106, 1106, 1106, 1106, 1106, 1106,
     1106, 1107, 1107, 1107, 1107, 1107, 1107, 1107, 1107, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1109, 1109, 1109,
     1109, 1109, 1109, 1109, 1109, 1110, 1110, 1110, 1110, 1110,
     1110, 1110, 1110, 1111, 1111, 1111, 1111, 1111, 1111, 1111,

     1111, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1113,
     1113, 1113, 1113, 1113, 1113, 1113, 1113, 1114, 1114, 1114,
     1114, 1114, 1114, 1114, 1114, 1115, 1115, 1115, 1115, 1115,
     1115, 1115, 1115, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1117, 1117, 1117, 1117, 1117, 1117, 1117, 1117, 1118,
        0,    0, 1118, 1119, 1119, 1119, 1119, 1119, 1119, 1119,
     1119, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1121,
     1121, 1121, 1121, 1121, 1121, 1121, 1121, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1123, 1123, 1123, 1123, 1123,
     1123, 1123, 1123, 1124, 1124, 1124, 1124, 1124, 1124, 1124,

     1124, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1126,
     1126, 1126, 1126, 1126, 1126, 1126, 1126, 1127, 1127, 1127,
     1127, 1127, 1127, 1127, 1127, 1128, 1128, 1128, 1128, 1128,
     1128, 1128, 1128, 1129, 1129, 1129, 1129, 1129, 1129, 1129,
     1129, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 1131,
     1131, 1131, 1131, 1131, 1131, 1131, 1131, 1132, 1132, 1132,
     1132, 1132, 1132, 1132, 1132, 1133, 1133, 1133, 1133, 1133,
     1133, 1133, 1133, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
     1134, 1135, 1135, 1135, 1135, 1135, 1135, 1135, 1135, 1136,
     1136, 1136, 1136, 1136, 1136, 1136, 1136, 1137, 1137, 1137,

     1137, 1137, 1137, 1137, 1137, 1138, 1138, 1138, 1138, 1138,
     1138, 1138, 1138, 1139, 1139, 1139, 1139, 1139, 1139, 1139,
     1139, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1141,
     1141, 1141, 1141, 1141, 1141, 1141, 1141, 1142, 1142, 1142,
     1142, 1142, 1142, 1142, 1142, 1143, 1143, 1143, 1143, 1143,
     1143, 1143, 1143, 1144,    0,    0, 1144, 1145, 1145, 1145,
     1145, 1145, 1145, 1145, 1145, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1147, 1147, 1147, 1147, 1147, 1147, 1147,
     1147, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1149,
     1149, 1149, 1149, 1149, 1149, 1149, 1149, 1150, 1150, 1150,

     1150, 1150, 1150, 1150, 1150, 1151, 1151, 1151, 1151, 1151,
     1151, 1151, 1151, 1152, 1152, 1152, 1152, 1152, 1152, 1152,
     1152, 1153, 1153, 1153, 1153, 1153, 1153, 1153, 1153, 1154,
     1154, 1154, 1154, 1154, 1154, 1154, 1154, 1155, 1155, 1155,
     1155, 1155, 1155, 1155, 1155, 1156, 1156, 1156, 1156, 1156,
     1156, 1156, 1156, 1157, 1157, 1157, 1157, 1157, 1157, 1157,
     1157, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1159,
     1159, 1159, 1159, 1159, 1159, 1159, 1159, 1160, 1160, 1160,
     1160, 1160, 1160, 1160, 1160, 1161, 1161, 1161, 1161, 1161,
     1161, 1161, 1161, 1162, 1162, 1162, 1162, 1162, 1162, 1162,

     1162, 1163, 1163, 1163, 1163, 1163, 1163, 1163, 1163, 1164,
     1164, 1164, 1164, 1164, 1164, 1164, 1164, 1165, 1165, 1165,
     1165, 1165, 1165, 1165, 1165, 1166, 1166, 1166, 1166, 1166,
     1166, 1166, 1166, 1167, 1167, 1167, 1167, 1167, 1167, 1167,
     1167, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1169,
     1169, 1169, 1169, 1169, 1169, 1169, 1169, 1170,    0,    0,
     1170, 1171, 1171, 1171, 1171, 1171, 1171, 1171, 1171, 1172,
     1172, 1172, 1172, 1172, 1172, 1172, 1172, 1173, 1173, 1173,
     1173, 1173, 1173, 1173, 1173, 1174, 1174, 1174, 1174, 1174,
     1174, 1174, 1174, 1175, 1175, 1175, 1175, 1175, 1175, 1175,

     1175, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1177,
     1177, 1177, 1177, 1177, 1177, 1177, 1177, 1178, 1178,    0,
     1178, 1178, 1178, 1178, 1178, 1179, 1179, 1179, 1179, 1179,
     1179, 1179, 1179, 1180, 1180,    0, 1180, 1180, 1180, 1180,
     1180, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006

    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 1;

static const short int yy_rule_linenum[48] =
    {   0,
      112,  117,  118,  126,  127,  128,  129,  130,  131,  132,
      133,  134,  135,  136,  137,  140,  144,  148,  156,  159,
      167,  168,  170,  171,  180,  181,  187,  188,  193,  194,
      199,  200,  205,  206,  211,  214,  216,  220,  224,  229,
      231,  232,  239,  245,  252,  255,  259
    } ;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
char *yytext;
#include "tokens.h"
#include <string.h>

	/* Current line number */
int currentLineNumber = 1;
void yyResetLineNumber() { currentLineNumber = 1; }

extern void yyerror(const char *);

	/* The YACC parser sets this to a token to direct the lexer */
    /* in cases where just syntax isn't enough: */
int expectToken = 0;

	/* True when parsing a multiple-valued field: */
static int parsing_mf = 0;

	/* These are used when parsing SFImage fields: */
static int sfImageIntsParsed = 0;
static int sfImageIntsExpected = 0;

int yywrap() { BEGIN INITIAL; return 1; }

/* Normal state:  parsing nodes.  The initial start state is used */
/* only to recognize the VRML header. */
/* Start tokens for all of the field types, */
/* except for MFNode and SFNode, which are almost completely handled */
/* by the parser: */
/* Big hairy expression for floating point numbers: */
/* Ints are decimal or hex (0x##): */
/* Whitespace.  Using this pattern can screw up currentLineNumber, */
/* so it is only used wherever it is really convenient and it is */
/* extremely unlikely that the user will put in a carriage return */
/* (example: between the floats in an SFVec3f) */
/* And the same pattern without the newline */
/* Legal characters to start an identifier */
/* Legal other characters in an identifier */

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#if __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( yy_current_buffer->yy_is_interactive ) \
		{ \
		int c = getc( yyin ); \
		result = c == EOF ? 0 : 1; \
		buf[0] = (char) c; \
		} \
	else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) \
		  && ferror( yyin ) ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL int yylex YY_PROTO(( void ))
#endif

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

YY_DECL
	{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;




	/* Switch into a new start state if the parser */
    /* just told us that we've read a field name */
    /* and should expect a field value (or IS) */
	if (expectToken != 0) {
      if (yy_flex_debug)
          fprintf(stderr,"LEX--> Start State %d\n", expectToken);
      
      /*
       * Annoying.  This big switch is necessary because
       * LEX wants to assign particular numbers to start
       * tokens, and YACC wants to define all the tokens
       * used, too.  Sigh.
       */
      switch(expectToken) {
       	case SFBOOL: BEGIN SFB; break;
        case SFCOLOR: BEGIN SFC; break;
        case SFFLOAT: BEGIN SFF; break;
        case SFIMAGE: BEGIN SFIMG; break;
        case SFINT32: BEGIN SFI; break;
        case SFROTATION: BEGIN SFR; break;
        case SFSTRING: BEGIN SFS; break;
        case SFTIME: BEGIN SFT; break;
        case SFVEC2F: BEGIN SFV2; break;
        case SFVEC3F: BEGIN SFV3; break;
        case MFCOLOR: BEGIN MFC; break;
        case MFFLOAT: BEGIN MFF; break;
        case MFINT32: BEGIN MFI; break;
        case MFROTATION: BEGIN MFR; break;
        case MFSTRING: BEGIN MFS; break;
        case MFVEC2F: BEGIN MFV2; break;
        case MFVEC3F: BEGIN MFV3; break;

        /* SFNode and MFNode are special.  Here the lexer just returns */
        /* "marker tokens" so the parser knows what type of field is */
        /* being parsed; unlike the other fields, parsing of SFNode/MFNode */
        /* field happens in the parser. */
        case MFNODE: expectToken = 0; return MFNODE;
        case SFNODE: expectToken = 0; return SFNODE;
        
        default: yyerror("ACK: Bad expectToken"); break;
      }
    }


	/* These are more complicated than they really need to be because */
    /* I was ambitious and made the whitespace-matching rules aggressive */

	if ( yy_init )
		{
#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! yy_start )
			yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( yy_current_buffer )
			yy_init_buffer( yy_current_buffer, yyin );
		else
			yy_current_buffer =
				yy_create_buffer( yyin, YY_BUF_SIZE );

		yy_load_buffer_state();

		yy_init = 0;
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yy_start;
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				yy_last_accepting_state = yy_current_state;
				yy_last_accepting_cpos = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 1007 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 8542 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];

		YY_DO_BEFORE_ACTION;


do_action:	/* This label is used only to access EOF actions. */

		if ( yy_flex_debug )
			{
			if ( yy_act == 0 )
				fprintf( stderr, "--scanner backing up\n" );
			else if ( yy_act < 48 )
				fprintf( stderr, "--accepting rule at line %d (\"%s\")\n",
				         yy_rule_linenum[yy_act], yytext );
			else if ( yy_act == 48 )
				fprintf( stderr, "--accepting default rule (\"%s\")\n",
				         yytext );
			else if ( yy_act == 49 )
				fprintf( stderr, "--(end of buffer or a NUL)\n" );
			else
				fprintf( stderr, "--EOF (start condition %d)\n", YY_START );
			}

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = yy_hold_char;
			yy_cp = yy_last_accepting_cpos;
			yy_current_state = yy_last_accepting_state;
			goto yy_find_action;

case 1:
YY_USER_ACTION
{
					  			  yyerror("VRML 2.0 final header found\n"
                      		      "This tool based on VRML Draft #2\n");
                                  BEGIN NODE;
                                }
	YY_BREAK
case 2:
YY_USER_ACTION
{ BEGIN NODE; }
	YY_BREAK
case 3:
YY_USER_ACTION
{ yyerror("Not a VRML Draft #2 file: bad header\n"
							  "#VRML Draft #2 V2.0 utf8  is correct header");
                      return 0;
                    }
	YY_BREAK
	/* The lexer is in the NODE state when parsing nodes, either */
    /* top-level nodes in the .wrl file, in a prototype implementation, */
    /* or when parsing the contents of SFNode or MFNode fields. */
case 4:
YY_USER_ACTION
{ return PROTO; }
	YY_BREAK
case 5:
YY_USER_ACTION
{ return EXTERNPROTO; }
	YY_BREAK
case 6:
YY_USER_ACTION
{ return DEF; }
	YY_BREAK
case 7:
YY_USER_ACTION
{ return USE; }
	YY_BREAK
case 8:
YY_USER_ACTION
{ return TO; }
	YY_BREAK
case 9:
YY_USER_ACTION
{ return IS; }
	YY_BREAK
case 10:
YY_USER_ACTION
{ return ROUTE; }
	YY_BREAK
case 11:
YY_USER_ACTION
{ return SFN_NULL; }
	YY_BREAK
case 12:
YY_USER_ACTION
{ return EVENTIN; }
	YY_BREAK
case 13:
YY_USER_ACTION
{ return EVENTOUT; }
	YY_BREAK
case 14:
YY_USER_ACTION
{ return FIELD; }
	YY_BREAK
case 15:
YY_USER_ACTION
{ return EXPOSEDFIELD; }
	YY_BREAK
	/* Legal identifiers: */
case 16:
YY_USER_ACTION
{ yylval.string = strdup(yytext);
									  return IDENTIFIER; }
	YY_BREAK
	/* All fields may have an IS declaration: */
case 17:
YY_USER_ACTION
{ BEGIN NODE;
													  expectToken = 0;
                                                      yyless(0);
                                                    }
	YY_BREAK
case 18:
YY_USER_ACTION
{ BEGIN NODE;
									    expectToken = 0;
                                        yyless(0); /* put back the IS */
                                      }
	YY_BREAK
    /* All MF field types other than MFNode are completely parsed here */
    /* in the lexer, and one token is returned to the parser.  They all */
    /* share the same rules for open and closing brackets: */
case 19:
YY_USER_ACTION
{ if (parsing_mf) yyerror("Double [");
									  parsing_mf = 1;
                                    }
	YY_BREAK
case 20:
YY_USER_ACTION
{ if (!parsing_mf) yyerror("Unmatched ]");
									  int fieldType = expectToken;
									  BEGIN NODE;
                                      parsing_mf = 0;
                                      expectToken = 0;
                                      return fieldType;
                                    }
	YY_BREAK
case 21:
YY_USER_ACTION
{ BEGIN NODE; expectToken = 0; return SFBOOL; }
	YY_BREAK
case 22:
YY_USER_ACTION
{ BEGIN NODE; expectToken = 0; return SFBOOL; }
	YY_BREAK
case 23:
YY_USER_ACTION
{ BEGIN NODE; expectToken = 0; return SFINT32; }
	YY_BREAK
case 24:
YY_USER_ACTION
{ if (parsing_mf) ;
					/* A real implementation would add the float to an */
                    /* array...  but here we do nothing */
				  else {
                  	  BEGIN NODE; expectToken = 0; return MFINT32;
                  }
                }
	YY_BREAK
	/* All the floating-point types are pretty similar: */
case 25:
YY_USER_ACTION
{ BEGIN NODE; expectToken = 0; return SFFLOAT; }
	YY_BREAK
case 26:
YY_USER_ACTION
{ if (parsing_mf) ; /* Add to array... */
                  	  else {
                      	/* No open bracket means a single value: */
                        BEGIN NODE; expectToken = 0; return MFFLOAT;
                      }
                    }
	YY_BREAK
case 27:
YY_USER_ACTION
{ BEGIN NODE; expectToken = 0; return SFVEC2F; }
	YY_BREAK
case 28:
YY_USER_ACTION
{ if (parsing_mf) ; /* .. add to array... */
              		  		  else {
                              	BEGIN NODE; expectToken = 0; return MFVEC2F;
                              }
                            }
	YY_BREAK
case 29:
YY_USER_ACTION
{ BEGIN NODE; expectToken = 0; return SFVEC3F; }
	YY_BREAK
case 30:
YY_USER_ACTION
{ if (parsing_mf) ; /* .. add to array... */
              					  else {
                                    BEGIN NODE; expectToken = 0; return MFVEC3F;
                                  }
                                }
	YY_BREAK
case 31:
YY_USER_ACTION
{ BEGIN NODE; expectToken = 0; return SFROTATION; }
	YY_BREAK
case 32:
YY_USER_ACTION
{ if (parsing_mf) ; /* .. add to array... */
			              		  else {
                                    BEGIN NODE; expectToken = 0; return MFROTATION;
                                  }
                                }
	YY_BREAK
case 33:
YY_USER_ACTION
{ BEGIN NODE; expectToken = 0; return SFCOLOR; }
	YY_BREAK
case 34:
YY_USER_ACTION
{ if (parsing_mf) ; /* .. add to array... */
			              		  else {
                                    BEGIN NODE; expectToken = 0; return MFCOLOR;
                                  }
                                }
	YY_BREAK
case 35:
YY_USER_ACTION
{ BEGIN NODE; expectToken = 0; return SFTIME; }
	YY_BREAK
    /* SFString/MFString */
case 36:
YY_USER_ACTION
{ BEGIN IN_SFS; }
	YY_BREAK
	/* Anything besides open-quote (or whitespace) is an error: */
case 37:
YY_USER_ACTION
{ yyerror("String missing open-quote");
						  BEGIN NODE; expectToken = 0; return SFSTRING;
                        }
	YY_BREAK
    /* Expect open-quote, open-bracket, or whitespace: */
case 38:
YY_USER_ACTION
{ yyerror("String missing open-quote");
						  	  BEGIN NODE; expectToken = 0; return MFSTRING;
                            }
	YY_BREAK
    /* Backslashed-quotes are OK: */
case 39:
YY_USER_ACTION
;
	YY_BREAK
    /* Gobble up anything besides quotes and newlines. */
    /* Newlines are legal in strings, but we exclude them here so */
    /* that line number are counted correctly by the catch-all newline */
    /* rule that applies to everything. */
case 40:
YY_USER_ACTION
;
	YY_BREAK
	/* Quote ends the string: */
case 41:
YY_USER_ACTION
{ BEGIN NODE; expectToken = 0; return SFSTRING; }
	YY_BREAK
case 42:
YY_USER_ACTION
{ if (parsing_mf) ; /* ... add to array ... */
						  else {
                          	  BEGIN NODE; expectToken = 0; return MFSTRING;
                          }
                        }
	YY_BREAK
    /* SFImage: width height numComponents then width*height integers: */
case 43:
YY_USER_ACTION
{ int w, h;
						  sscanf(yytext, "%d %d", &w, &h);
                          sfImageIntsExpected = 1+w*h;
                          sfImageIntsParsed = 0;                          
                          BEGIN IN_SFIMG;
                        }
	YY_BREAK
case 44:
YY_USER_ACTION
{ ++sfImageIntsParsed;
						  if (sfImageIntsParsed == sfImageIntsExpected) {
                          	  BEGIN NODE; expectToken = 0; return SFIMAGE;
                          }
                        }
	YY_BREAK
	/* Whitespace and catch-all rules apply to all start states: */
case 45:
YY_USER_ACTION
;
	YY_BREAK
	/* This is also whitespace, but we'll keep track of line number */
    /* to report in errors: */
case 46:
YY_USER_ACTION
{ ++currentLineNumber; }
	YY_BREAK
	/* This catch-all rule catches anything not covered by any of */
    /* the above: */
case 47:
YY_USER_ACTION
{ return yytext[0]; }
	YY_BREAK
case 48:
YY_USER_ACTION
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(NODE):
case YY_STATE_EOF(SFB):
case YY_STATE_EOF(SFC):
case YY_STATE_EOF(SFF):
case YY_STATE_EOF(SFIMG):
case YY_STATE_EOF(SFI):
case YY_STATE_EOF(SFR):
case YY_STATE_EOF(SFS):
case YY_STATE_EOF(SFT):
case YY_STATE_EOF(SFV2):
case YY_STATE_EOF(SFV3):
case YY_STATE_EOF(MFC):
case YY_STATE_EOF(MFF):
case YY_STATE_EOF(MFI):
case YY_STATE_EOF(MFR):
case YY_STATE_EOF(MFS):
case YY_STATE_EOF(MFV2):
case YY_STATE_EOF(MFV3):
case YY_STATE_EOF(IN_SFS):
case YY_STATE_EOF(IN_MFS):
case YY_STATE_EOF(IN_SFIMG):
	yyterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = yy_cp - yytext_ptr - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yy_hold_char;

		if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between yy_current_buffer and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yy_n_chars = yy_current_buffer->yy_n_chars;
			yy_current_buffer->yy_input_file = yyin;
			yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state();

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
							yy_cp = yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer() )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yy_did_buffer_switch_on_eof = 0;

				if ( yywrap() )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yy_c_buf_p =
					yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yy_c_buf_p =
				&yy_current_buffer->yy_ch_buf[yy_n_chars];

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of yylex */


/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

static int yy_get_next_buffer()
	{
	register char *dest = yy_current_buffer->yy_ch_buf;
	register char *source = yytext_ptr - 1; /* copy prev. char, too */
	register int number_to_move, i;
	int ret_val;

	if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( yy_current_buffer->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a singled characater, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = yy_c_buf_p - yytext_ptr;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		yy_n_chars = 0;

	else
		{
		int num_to_read =
			yy_current_buffer->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */
#ifdef YY_USES_REJECT
			YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );
#else

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = yy_current_buffer;

			int yy_c_buf_p_offset = yy_c_buf_p - b->yy_ch_buf;

			b->yy_buf_size *= 2;
			b->yy_ch_buf = (char *)
				yy_flex_realloc( (void *) b->yy_ch_buf,
						 b->yy_buf_size );

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = yy_current_buffer->yy_buf_size -
						number_to_move - 1;
#endif
			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
			yy_n_chars, num_to_read );
		}

	if ( yy_n_chars == 0 )
		{
		if ( number_to_move - YY_MORE_ADJ == 1 )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			yy_current_buffer->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	yy_n_chars += number_to_move;
	yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	/* yytext begins at the second character in yy_ch_buf; the first
	 * character is the one which preceded it before reading in the latest
	 * buffer; it needs to be kept around in case it's a newline, so
	 * yy_get_previous_state() will have with '^' rules active.
	 */

	yytext_ptr = &yy_current_buffer->yy_ch_buf[1];

	return ret_val;
	}


/* yy_get_previous_state - get the state just before the EOB char was reached */

static yy_state_type yy_get_previous_state()
	{
	register yy_state_type yy_current_state;
	register char *yy_cp;

	yy_current_state = yy_start;

	for ( yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			yy_last_accepting_state = yy_current_state;
			yy_last_accepting_cpos = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 1007 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
	}


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */

#ifdef YY_USE_PROTOS
static yy_state_type yy_try_NUL_trans( yy_state_type yy_current_state )
#else
static yy_state_type yy_try_NUL_trans( yy_current_state )
yy_state_type yy_current_state;
#endif
	{
	register int yy_is_jam;
	register char *yy_cp = yy_c_buf_p;

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		yy_last_accepting_state = yy_current_state;
		yy_last_accepting_cpos = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 1007 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 1006);

	return yy_is_jam ? 0 : yy_current_state;
	}


#ifdef YY_USE_PROTOS
static void yyunput( int c, register char *yy_bp )
#else
static void yyunput( c, yy_bp )
int c;
register char *yy_bp;
#endif
	{
	register char *yy_cp = yy_c_buf_p;

	/* undo effects of setting up yytext */
	*yy_cp = yy_hold_char;

	if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yy_n_chars + 2;
		register char *dest = &yy_current_buffer->yy_ch_buf[
					yy_current_buffer->yy_buf_size + 2];
		register char *source =
				&yy_current_buffer->yy_ch_buf[number_to_move];

		while ( source > yy_current_buffer->yy_ch_buf )
			*--dest = *--source;

		yy_cp += dest - source;
		yy_bp += dest - source;
		yy_n_chars = yy_current_buffer->yy_buf_size;

		if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	if ( yy_cp > yy_bp && yy_cp[-1] == '\n' )
		yy_cp[-2] = '\n';

	*--yy_cp = (char) c;


	/* Note: the formal parameter *must* be called "yy_bp" for this
	 * macro to now work correctly.
	 */
	YY_DO_BEFORE_ACTION; /* set up yytext again */
	}


#ifdef __cplusplus
static int yyinput()
#else
static int input()
#endif
	{
	int c;

	*yy_c_buf_p = yy_hold_char;

	if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			/* This was really a NUL. */
			*yy_c_buf_p = '\0';

		else
			{ /* need more input */
			yytext_ptr = yy_c_buf_p;
			++yy_c_buf_p;

			switch ( yy_get_next_buffer() )
				{
				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap() )
						{
						yy_c_buf_p =
						yytext_ptr + YY_MORE_ADJ;
						return EOF;
						}

					YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;
					break;

				case EOB_ACT_LAST_MATCH:
#ifdef __cplusplus
					YY_FATAL_ERROR(
					"unexpected last match in yyinput()" );
#else
					YY_FATAL_ERROR(
					"unexpected last match in input()" );
#endif
				}
			}
		}

	c = *(unsigned char *) yy_c_buf_p;	/* cast for 8-bit char's */
	*yy_c_buf_p = '\0';	/* preserve yytext */
	yy_hold_char = *++yy_c_buf_p;

	return c;
	}


#ifdef YY_USE_PROTOS
void yyrestart( FILE *input_file )
#else
void yyrestart( input_file )
FILE *input_file;
#endif
	{
	if ( ! yy_current_buffer )
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );

	yy_init_buffer( yy_current_buffer, input_file );
	yy_load_buffer_state();
	}


#ifdef YY_USE_PROTOS
void yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
#else
void yy_switch_to_buffer( new_buffer )
YY_BUFFER_STATE new_buffer;
#endif
	{
	if ( yy_current_buffer == new_buffer )
		return;

	if ( yy_current_buffer )
		{
		/* Flush out information for old buffer. */
		*yy_c_buf_p = yy_hold_char;
		yy_current_buffer->yy_buf_pos = yy_c_buf_p;
		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	yy_current_buffer = new_buffer;
	yy_load_buffer_state();

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yy_did_buffer_switch_on_eof = 1;
	}


#ifdef YY_USE_PROTOS
void yy_load_buffer_state( void )
#else
void yy_load_buffer_state()
#endif
	{
	yy_n_chars = yy_current_buffer->yy_n_chars;
	yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
	yyin = yy_current_buffer->yy_input_file;
	yy_hold_char = *yy_c_buf_p;
	}


#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )
#else
YY_BUFFER_STATE yy_create_buffer( file, size )
FILE *file;
int size;
#endif
	{
	YY_BUFFER_STATE b;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );

	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yy_flex_alloc( b->yy_buf_size + 2 );

	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	yy_init_buffer( b, file );

	return b;
	}


#ifdef YY_USE_PROTOS
void yy_delete_buffer( YY_BUFFER_STATE b )
#else
void yy_delete_buffer( b )
YY_BUFFER_STATE b;
#endif
	{
	if ( b == yy_current_buffer )
		yy_current_buffer = (YY_BUFFER_STATE) 0;

	yy_flex_free( (void *) b->yy_ch_buf );
	yy_flex_free( (void *) b );
	}


#ifdef YY_USE_PROTOS
void yy_init_buffer( YY_BUFFER_STATE b, FILE *file )
#else
void yy_init_buffer( b, file )
YY_BUFFER_STATE b;
FILE *file;
#endif
	{
	b->yy_input_file = file;

	/* We put in the '\n' and start reading from [1] so that an
	 * initial match-at-newline will be true.
	 */

	b->yy_ch_buf[0] = '\n';
	b->yy_n_chars = 1;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[2] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[1];

	b->yy_is_interactive = file ? isatty( fileno(file) ) : 0;

	b->yy_fill_buffer = 1;

	b->yy_buffer_status = YY_BUFFER_NEW;
	}


#ifdef YY_USE_PROTOS
static void yy_push_state( int new_state )
#else
static void yy_push_state( new_state )
int new_state;
#endif
	{
	if ( yy_start_stack_ptr >= yy_start_stack_depth )
		{
		int new_size;

		yy_start_stack_depth += YY_START_STACK_INCR;
		new_size = yy_start_stack_depth * sizeof( int );

		if ( ! yy_start_stack )
			yy_start_stack = (int *) yy_flex_alloc( new_size );

		else
			yy_start_stack = (int *) yy_flex_realloc(
					(void *) yy_start_stack, new_size );

		if ( ! yy_start_stack )
			YY_FATAL_ERROR(
			"out of memory expanding start-condition stack" );
		}

	yy_start_stack[yy_start_stack_ptr++] = YY_START;

	BEGIN(new_state);
	}


static void yy_pop_state()
	{
	if ( --yy_start_stack_ptr < 0 )
		YY_FATAL_ERROR( "start-condition stack underflow" );

	BEGIN(yy_start_stack[yy_start_stack_ptr]);
	}


static int yy_top_state()
	{
	return yy_start_stack[yy_start_stack_ptr - 1];
	}


#ifdef YY_USE_PROTOS
static void yy_fatal_error( const char msg[] )
#else
static void yy_fatal_error( msg )
char msg[];
#endif
	{
	(void) fprintf( stderr, "%s\n", msg );
	exit( 1 );
	}



/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		yytext[yyleng] = yy_hold_char; \
		yy_c_buf_p = yytext + n - YY_MORE_ADJ; \
		yy_hold_char = *yy_c_buf_p; \
		*yy_c_buf_p = '\0'; \
		yyleng = n; \
		} \
	while ( 0 )


/* Internal utility routines. */

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void yy_flex_strncpy( char *s1, const char *s2, int n )
#else
static void yy_flex_strncpy( s1, s2, n )
char *s1;
const char *s2;
int n;
#endif
	{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
	}
#endif


#ifdef YY_USE_PROTOS
static void *yy_flex_alloc( unsigned int size )
#else
static void *yy_flex_alloc( size )
unsigned int size;
#endif
	{
	return (void *) malloc( size );
	}

#ifdef YY_USE_PROTOS
static void *yy_flex_realloc( void *ptr, unsigned int size )
#else
static void *yy_flex_realloc( ptr, size )
void *ptr;
unsigned int size;
#endif
	{
	return (void *) realloc( ptr, size );
	}

#ifdef YY_USE_PROTOS
static void yy_flex_free( void *ptr )
#else
static void yy_flex_free( ptr )
void *ptr;
#endif
	{
	free( ptr );
	}
